﻿//   Copyright IBM Corp. 1998 - 2004 All Rights Reserved

// Begin Global Variables

var m_sFrameListObjectName;		// When an action occurs, stores the id of the object the action occured on
var m_nTimeoutID;		// Stores the ID of the timeout for auto advancing
var m_arrHistoryNav = new Array();		// Stores the History of Student Navigation
var m_nHistoryCurIdx = -1;
var m_sLayerName = "";  // The name of the last layer shown
var m_bPooledEvent = false;

// End Global Variables

// Begin Event Navigation Highlevel API's

function GotoEvent(lEventID,sSCOID) {
//	m_bPersist = m_bPersistData;
	saveHistory(lEventID);
	lEventID = GetEventRefNumFromName(lEventID);
	loadEvent(lEventID,null,sSCOID);
}

function GotoEventWithBookmarkAnchor(lEventID,sBMAnchor) {
//	m_bPersist = m_bPersistData;
	saveHistory(lEventID);
	lEventID = GetEventRefNumFromName(lEventID);
	loadEvent(lEventID,null,null,sBMAnchor);
}

function GotoNextEvent() {
//	m_bPersist = m_bPersistData;
	var oNavLink;
	var oNextNavLink;
	var curseq;
	
	if (m_sNavigationBehavior == "standard" || m_sNavigationBehavior == "no return"){
		oNavLink = findNavLink(1,m_lEventID);
		oNextNavLink = findNavLinkWithOrgAndSeq(oNavLink.ORGTYPE,oNavLink.ORGID,oNavLink.SEQUENCE+1);
		if (oNextNavLink != null) {
			saveHistory(oNextNavLink.DSTID);
			loadEvent(oNextNavLink.DSTID);
		} else {
			if (m_sNavigationBehavior == "standard"){
				GotoParentEvent();
			}	
		}
	}else{
		if (arrTreeNav[nTreeNavPos+1] != null){
			saveHistory(arrTreeNav[nTreeNavPos+1]);
			loadEvent(arrTreeNav[nTreeNavPos+1]);
		}
	}	
}

function GotoPreviousEvent() {
//	m_bPersist = m_bPersistData;
	var oNavLink;
	var oPrevNavLink;
	var curseq;
	if (m_sNavigationBehavior == "standard" || m_sNavigationBehavior == "no return"){
		oNavLink = findNavLink(1,m_lEventID);
		oPrevNavLink = findNavLinkWithOrgAndSeq(oNavLink.ORGTYPE,oNavLink.ORGID,oNavLink.SEQUENCE-1);
		if (oPrevNavLink != null) {
			saveHistory(oPrevNavLink.DSTID);
			loadEvent(oPrevNavLink.DSTID);
		} else {
			if (m_sNavigationBehavior == "standard"){
				GotoParentEvent();
			}	
		}
	}else{
		if (arrTreeNav[nTreeNavPos-1] != null){
			saveHistory(arrTreeNav[nTreeNavPos-1]);
			loadEvent(arrTreeNav[nTreeNavPos-1]);
		}
	}	
}

function GotoParentEvent() {
//	m_bPersist = m_bPersistData;
	var oNavLink;
	var oParentNavLink;
	oNavLink = findNavLink(1,m_lEventID);
	oParentNavLink = findNavLink(oNavLink.ORGTYPE,oNavLink.ORGID);
	// Handle top-level case
	if (oParentNavLink.DSTTYPE == 2 && oParentNavLink.DSTID == 1) {
		return null;
	}
	if (oParentNavLink != null) {
		saveHistory(oParentNavLink.ORGID);
		loadEvent(oParentNavLink.ORGID);
	}
}

function ReloadEvent() {
	//CP.m_bPersistData = false;
	m_arrEvents[String(CP.m_lEventID)].RELOADING = true;
	DeleteEventAllData(m_lEventID);
	m_arrEvents[String(m_lEventID)].STATE=""
	loadEvent(m_lEventID,1);
}

function GotoFirstEvent() {
//	m_bPersist = m_bPersistData;
	CP.GotoEvent(CP.GetFirstEvent());
}

// !!! Doesn't work in Mozilla...need better way to do this
// Had to change...will affect migration!!!
function GotoChildEvent(obj) {
	var sID = getID(obj).substring(4,255);
	GotoChildNavWithEventID(m_lEventID,sID);
}

function GotoChildNav(sNavLinkName) {
	GotoChildNavWithEventID(m_lEventID,sNavLinkName);
}

function GotoChildNavWithEventID(lEventID,sNavLinkName,lFrameID) {
//	m_bPersist = m_bPersistData;
//	if (lFrameID == null) {
//		lFrameID = 1;
//	}
	var oNav;
	var oNavLink;
	lEventID = GetEventRefNumFromName(lEventID);

	for (var i=0; i<m_arrNavLinks.length; i++) {
		if (m_arrNavLinks[i].ORGTYPE == 1 && m_arrNavLinks[i].ORGID == lEventID) {
			oNav = findNav(m_arrNavLinks[i].DSTID);
			if (oNav.NAME.toLowerCase() == sNavLinkName.toLowerCase()) {
				oNavLink = findNavLinkWithOrgAndSeq(2,oNav.ID,1);
				if (oNavLink != null) {
					lFrameID = GetFrameIndexFromName(oNavLink.DSTID,lFrameID);
					saveHistory(oNavLink.DSTID);
					loadEvent(oNavLink.DSTID,lFrameID);
				}
			}
		}
	}
}

function GotoChildNavAndFrameWithEventID(lEventID,sNavLinkName,lFrameID) {
	GotoChildNavWithEventID(lEventID,sNavLinkName,lFrameID);
}

function GotoEventIfBookmark() {
	if (m_bBookmarkHasParent) {
		m_bBookmarkHasParent = false;
		GotoEvent(m_lBookmarkEventID);
	}
}

// End Event Navigation Highevel API's


// Begin Frame Navigation Highevel API's

function GotoFrame(lFrameID) {
	lFrameID = GetFrameIndexFromName(m_lEventID,lFrameID);
	loadFrame(m_lAliasID,lFrameID);
}

function GotoFrameWithBookmarkAnchor(lFrameID, sBMAnchor) {
	lFrameID = GetFrameIndexFromName(m_lEventID,lFrameID);
	loadFrame(m_lAliasID,lFrameID,null,sBMAnchor);
}


function GotoNextFrame(){
	if (parseInt(m_lFrameID)+1 <= GetTotalFrames()) {
		loadFrame(m_lAliasID,parseInt(m_lFrameID)+1);
		return true;
	} else {
		return false;
	}	
}

function GotoPreviousFrame() {
	if (m_lFrameID > 1) {
		loadFrame(m_lAliasID,parseInt(m_lFrameID)-1);
		return true;
	} else {
		return false;
	}
}

// End Frame Navigation Highevel API's

// Begin Layer Navigation Highevel API's - JJB - 10/20/2004
function GotoLayerByName(lLayerIndex,sPrefix,bPersistPrevious) {
	if (sPrefix == null) {
		sPrefix = "Frame ";
	}
	if (bPersistPrevious == null) {
		bPersistPrevious = false;
	}
	if (lLayerIndex != GetLayerIndex()) {
		// Show Layer
		CP.ShowLayer(sPrefix + String(lLayerIndex));
		if (bPersistPrevious == false) {
			CP.HideLayer(sPrefix + String(GetLayerIndex()));
		}	
	}

	// Update Index
	m_lLayerIndex = lLayerIndex;
}
/*
function GotoNextLayerByName(sPrefix,bPersistPrevious) {
	if (GetLayerIndex() < GetTotalLayers()) {
		CP.GotoLayer(GetLayerIndex()+1,sPrefix,bPersistPrevious);
	}
}

function GotoPreviousLayerByName(sPrefix,bPersistPrevious) {
	if (GetLayerIndex() > 1) {
		CP.GotoLayer(GetLayerIndex()-1,sPrefix,bPersistPrevious);
	}
}
*/
function GotoLayer(sLayerName,targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
	ShowLayer(sLayerName,targetwindow);
}

function GotoNextLayer(targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
/*	
	if (bPersistPrevious == null){
		bPersistPrevious = false;	
	}	
*/	
	if (m_sLayerName == ""){
		return;
	}	
	if (targetwindow.arrCPLayers[m_sLayerName].NEXT != ""){
		var sLayerName = m_sLayerName;
		ShowLayer(targetwindow.arrCPLayers[m_sLayerName].NEXT,targetwindow);
		//if (bPersistPrevious == false){
			HideLayer(sLayerName,targetwindow,true);
		//}
	}		
}	

function GotoPreviousLayer(targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
	if (m_sLayerName == ""){
		return;
	}	
	if (targetwindow.arrCPLayers[m_sLayerName].PREVIOUS != ""){
		var sLayerName = m_sLayerName;
		ShowLayer(targetwindow.arrCPLayers[m_sLayerName].PREVIOUS,targetwindow);
		HideLayer(sLayerName,targetwindow,false);
	}		
}	






// End Layer Navigation Highevel API's

// Begin Event and/or Frame Navigation Highevel API's

function GotoEventAndFrame(lEventID,lFrameID,sSCOID) {
//	m_bPersist = m_bPersistData;
	lEventID = GetEventRefNumFromName(lEventID);
	saveHistory(lEventID);
	lFrameID = GetFrameIndexFromName(lEventID,lFrameID);
	loadEvent(lEventID,lFrameID,sSCOID);
}

function GotoNext() {
	if (!GotoNextFrame()) {
		GotoNextEvent();
	}
}

function GotoPrevious() {
	if (!GotoPreviousFrame()) {
		GotoPreviousEvent();
	}
}

// End Event and/or Frame Navigation Highevel API's

// Being Event History Navigation Highevel API's

function GotoHistoryNext() {
	if (m_arrHistoryNav[m_nHistoryCurIdx+1] != null){
		m_nHistoryCurIdx++;
		loadEvent(m_arrHistoryNav[m_nHistoryCurIdx]);		
	}		
}	

function GotoHistoryPrevious() {
	if (m_arrHistoryNav[m_nHistoryCurIdx-1] != null){
		m_nHistoryCurIdx--;
		loadEvent(m_arrHistoryNav[m_nHistoryCurIdx]);		
	}		
}

// End Event History Navigation Highevel API's

// Being Event AutoAdvance Navigation Highevel API's

function AutoAdvanceGotoNextEvent(timeout) {
	m_nTimeoutID = setTimeout('GotoNextEvent()',parseInt(timeout));
}

function AutoAdvanceGotoNextFrame(timeout) {
	m_nTimeoutID = setTimeout('GotoNextFrame()',parseInt(timeout));
	return m_nTimeoutID;
}

function AutoAdvance(sFunctionName,timeout) {
	m_nTimeoutID = setTimeout(sFunctionName,parseInt(timeout));
	return m_nTimeoutID;
}

// End Event AutoAdvance Navigation Highevel API's

// Begin Supporting Navagtion Get API's

function GetEventID() {
	return m_lEventID;
}
function GetFirstEvent() {
	var oNavLink = findNavLinkWithOrgAndSeq(2,1,1);
	return oNavLink.DSTID;
}

// what's the point of this one?
function GetCurrentEventRefNumFromName(){
	return GetEventRefNumFromName(m_lEventID);
}	

function GetEventRefNumFromName(sEventName){
	if ((""+parseInt(sEventName))=="NaN"){
		var i;
		for (i in m_arrEvents){
			if (m_arrEvents[i].NAME == sEventName){
				return m_arrEvents[i].ID;
			}	
		}	
		return "";
	}
	return sEventName;		
}

function GetCurrentEventParentID() {
	return GetParentEventID(m_lEventID)
}

function GetParentEventID(sEventID) {
	var lEventID = GetEventRefNumFromName(sEventID);
	var objNavLink = findNavLink(1,lEventID);
	var objParentNavLink = findNavLink(2,objNavLink.ORGID);
	return parseInt(objParentNavLink.ORGID);
}

function GetCurrentHistoryIndex(){
	return m_nHistoryCurIdx;
}	

function GetPreviousHistoryEventID(){
	if (m_arrHistoryNav[m_nHistoryCurIdx-1] != null){
		return m_arrHistoryNav[m_nHistoryCurIdx-1];		
	}
	return null;	
}

function GetNextHistoryEventID() {
	if (m_arrHistoryNav[m_nHistoryCurIdx+1] != null){
		return m_arrHistoryNav[m_nHistoryCurIdx+1];		
	}		
	return null;
}		

function GetFrameIndex() {
	return m_lFrameID;
}

function GetTotalFrames() {
	return m_lTotalFrames;
}

function GetFrameIndexFromName(sEventID,sFrameName){
	if (sFrameName == null) return null;

	var lEventID = GetEventRefNumFromName(sEventID);

	if ((""+parseInt(sFrameName))=="NaN"){
		return convertNull(m_arrEvents[String(lEventID)].arrFrames[String(sFrameName)]);
	}
	return sFrameName;		
}	

function GetFrameIndexFromNameForCurrentEvent(sFrameName){
	return GetFrameIndexFromName(m_lEventID,sFrameName);
}	

// JJB - 10/20/2004
function GetTotalLayers() {
	return m_arrEvents[String(m_lEventID)].m_lTotalLayers;
}

// JJB - 10/20/2004
function GetLayerIndex() {
	return m_lLayerIndex;
}

// End Supporting Navagtion Get API's


// Begin Non highlevel api used internally

function getTarget(lEventID) {
	if (lEventID > 1) {
		var sLocalTarget = m_arrEvents[String(lEventID)].TARGET;
		if (sLocalTarget == null || sLocalTarget == "") {
			if (m_sTarget == null || m_sTarget == "") {
				return "";
			} else {
				return m_sTarget;
			}
		} else {
			if (sLocalTarget.toLowerCase() == "root") {
				return "";
			} else {	
				return sLocalTarget;
			}	
		}
	} else {
		return "";
	}	
}

function getRandom(count) {
	// Look at to make sure everything getting proper weight
    var ranNum = Math.round(Math.random()*(count-1));
    return ranNum;
}

function loadEvent(lEventID,lFrameID,sSCOID,sBMAnchor) {
	// Check if this event has events to pool from
	// If it does, select one of them
	// use the scoid and eventid from there to load the event
	
	if (lEventID == ""){
		return;	
	}	
	m_bPooledEvent = false;
	lEventID = GetEventRefNumFromName(lEventID);
	lFrameID = GetFrameIndexFromName(lEventID,lFrameID);

	m_lLastEventID = m_lEventID;
	unswapImages();
	if (sSCOID == null) {
		if (m_arrEvents[String(lEventID)] == null){
			alert("Invalid Event Id - " + lEventID);
			return;
		}
		// First check to see if already used a pooled event...if so use them same one
		if (m_arrLastPool[String(lEventID)] != null) {
			m_lEventID = lEventID;
			lEventID = m_arrLastPool[String(m_lEventID)].POOLEDEVENTID;
			m_bPooledEvent = true;
			m_sAliasSCOID = m_arrLastPool[String(m_lEventID)].POOLEDSCOID;
		// If never used one, check to see if this is a pooled event	
		} else if (m_arrEvents[String(lEventID)].POOLEDQUESTIONS != null) {
			if (m_arrEvents[String(lEventID)].POOLEDQUESTIONS != "") {
				m_lEventID = lEventID;
				m_bPooledEvent = true;
				var arrPool = new Array();
				var sPool = m_arrEvents[String(lEventID)].POOLEDQUESTIONS;
				arrPool = sPool.split(";");
				
				var arrNewPool = new Array();
				var idx = 0;
				
				// Check if already used
				for (var j=0; j<arrPool.length; j++) {
					if (m_arrUsedPool[arrPool[j]] == null) {
						if (arrPool[j] != "") {
							arrNewPool[idx] = arrPool[j];
							idx++;
						}	
					}
				}
				
				if (arrNewPool.length == 0) {
					alert("Error! All of the pooled questions have been used.");
					return;
				}
				
				var nRandomIdx = getRandom(arrNewPool.length);
				var sEvent = arrNewPool[nRandomIdx];
				
				var arrParts = new Array();
				arrParts = sEvent.split("/");

				var arrFile = new Array();
				arrFile = arrParts[arrParts.length-1].split(".");
				lEventID = Number(arrFile[0]);

				m_sAliasSCOID = arrParts[0];
				for (var i=1; i<arrParts.length-1; i++) {
					m_sAliasSCOID = m_sAliasSCOID + "/" + arrParts[i];
				}
				
				m_arrLastPool[String(m_lEventID)] = new Object();
				
				m_arrLastPool[String(m_lEventID)].POOLEDEVENTID = lEventID;
				m_arrLastPool[String(m_lEventID)].POOLEDSCOID = m_sAliasSCOID;
				
				// Add to dictionary
				m_arrUsedPool[m_sAliasSCOID + "/" + lEventID + ".xml"] = m_sAliasSCOID + "/" + lEventID + ".xml";
				//get the pooled question's correct answer from the m_arrPooledAnswers object
				if (m_arrPooledAnswers[m_sAliasSCOID + "/" + lEventID + ".xml"] != null){
					for (var sObj in m_arrPooledAnswers[m_sAliasSCOID + "/" + lEventID + ".xml"].arrAnswers){
						m_arrEvents[String(m_lEventID)].arrAnswers[sObj] = m_arrPooledAnswers[m_sAliasSCOID + "/" + 	lEventID + ".xml"].arrAnswers[sObj];	
					}
					m_arrEvents[String(m_lEventID)].arrFrames = new Array();	
					for (var sObj in m_arrPooledQuestionFrames[m_sAliasSCOID + "/" + lEventID + ".xml"].arrFrames){
						m_arrEvents[String(m_lEventID)].arrFrames[m_arrPooledQuestionFrames[m_sAliasSCOID + "/" + lEventID + ".xml"].arrFrames[sObj]] = sObj;
					}	
				}					
				
			}
		} else {
			m_lEventID = lEventID;
			m_sAliasSCOID = m_sSCOID;
		}
	} else {
		// Previous event
		m_lEventID = m_lAliasID;
		m_sAliasSCOID = sSCOID;
	}
	if (lFrameID == null) {
		var persist = true;
		if (m_arrEvents[String(m_lEventID)].PERSIST != null) {
			if (m_arrEvents[String(m_lEventID)].PERSIST != "") {
				persist = m_arrEvents[String(m_lEventID)].PERSIST.toLowerCase()=="true"?true:false;
			}else{
				persist = m_bPersistData;
			}				
		}else{
			persist = m_bPersistData;
		}	
		
		if (persist) {
			if (m_arrEvents[String(m_lEventID)].LASTFRAMEID != null) {
				lFrameID = m_arrEvents[String(m_lEventID)].LASTFRAMEID;
			} else {
				lFrameID = 1;
			}	
		} else {
			DeleteEventAllData(m_lEventID);
			m_arrEvents[String(m_lEventID)].STATE="";
			lFrameID = 1;
		}	
	}	
	
	m_lEventTimeBegin = new Date();
	nTreeNavPos = getTreeNavPos();
	loadFrame(lEventID,lFrameID,true,sBMAnchor);
	
	// Only play intro audio if on first frame AND ONLY PLAY IT FROM HERE IF IT'S EXTERNAL URL	
	if (CP.m_lFrameID == 1 && convertNull(m_arrEvents[String(m_lEventID)].EXTERNALURL) != ""){
		CP.m_AudioSyncAction = "None"
		if (m_arrEvents[String(m_lEventID)].SYNCACTION != null) {
			CP.m_AudioSyncAction = m_arrEvents[String(m_lEventID)].SYNCACTION;
		}
		
		if (m_arrEvents[String(m_lEventID)].FILENAME != null) {
			if (m_arrEvents[String(m_lEventID)].FILENAME != "") {
				
				if (m_arrEvents[String(m_lEventID)].FILENAME.indexOf('[url]') != -1){
					m_arrEvents[String(m_lEventID)].FILENAME = m_arrEvents[String(m_lEventID)].FILENAME.substring(6,m_arrEvents[String(m_lEventID)].FILENAME.length);
					m_arrEvents[String(m_lEventID)].FILENAME = BuildFullURL(m_arrEvents[String(m_lEventID)].FILENAME);
				}else{
					CP.AudioPath("AudioPlayer",BuildFullURL("media/" + m_arrEvents[String(m_lEventID)].FILENAME),CP);
				}					
				CP.AudioPlay("AudioPlayer",CP);
			}
		}	
	}	

	// Question initialize
	m_nNumTries = 1;
	if (m_arrEvents[String(m_lEventID)].STATE != null){
	}else{
		m_arrEvents[String(m_lEventID)].STATE="";
	}		
}

function loadFrame(lEventID,lFrameID,bLoadEvent,sBMAnchor) {
	// clear any animation intervals
	for (var i=0;i<m_arrAnimationInterval.length;i++){
		clearInterval(m_arrAnimationInterval[i]);
	}	
	m_arrAnimationInterval = new Array();
	
	
	lEventID = GetEventRefNumFromName(lEventID);
	
	var sFilename = replaceAll(replaceAll(CP.m_sPublishedFilename,"{eventid}",lEventID),"{framenum}",lFrameID);
	var sExt = CP.m_sPublishedExtension;
	var sFullFilename = sFilename + "." + sExt;
			
	if (sBMAnchor==null){sBMAnchor="";}	
	var sExternalURL = convertNull(m_arrEvents[String(m_lEventID)].EXTERNALURL);
	if (sExternalURL.indexOf('[url]') != -1){
		sExternalURL = sExternalURL.substring(6,sExternalURL.length);
		sExternalURL = BuildFullURL(sExternalURL);
	}else{
		if (sExternalURL != ""){
			sExternalURL = BuildFullURL("media/" + sExternalURL);
		}			
	}		
	
	
	if (bLoadEvent == null) {
		bLoadEvent = false;
	}

	if (!bLoadEvent) {
		m_lLastEventID = m_lEventID;
	}	
	
	var sFontStyleCSS = "fontstyles.css";
	var sBorderStyleCSS = "borderstyles.css";

	if (m_bPooledEvent == true){
		sFontStyleCSS = replaceAll(replaceAll(m_sAliasSCOID,"/","-")," ","_") + "_" + sFontStyleCSS;
		sBorderStyleCSS = replaceAll(replaceAll(m_sAliasSCOID,"/","-")," ","_") + "_" + sBorderStyleCSS;
	}	

	// Need to handle IFRAME
	clearTimeout(m_nTimeoutID);
	m_lFrameID = lFrameID;
	sTarget = getTarget(m_lEventID);

	var xslProc;

	if (m_bDynamic && sExternalURL == "") {
		var xslt = new ActiveXObject("Msxml2.XSLTemplate");
		var xslDoc = new ActiveXObject("Msxml2.FreeThreadedDOMDocument");
		var xslProc;
		xslDoc.async = false;
		xslDoc.resolveExternals = false;
		xslDoc.load(m_sEngineDir + "/cppublish.xsl");
		xslt.stylesheet = xslDoc;
		var xmlDoc = new ActiveXObject("Msxml2.DOMDocument");
		xmlDoc.async = false;
		xmlDoc.resolveExternals = false;
		xmlDoc.load(m_sContentDir + "/scos/" + unescape(m_sAliasSCOID) + ".xml");
		xslProc = xslt.createProcessor();
		xslProc.input = xmlDoc;
		// need to get somehow
		xslProc.addParameter("cplibdir", m_sLibDir);
		xslProc.addParameter("enginedir", m_sEngineDir);
		xslProc.addParameter("contentdir", m_sContentDir);
	    xslProc.addParameter("multipubrel", m_bMultiPubRel);

		// may not need
		//xslProc.addParameter("sco", m_sAliasSCOID.replace("%5c","\\").replace("%20"," "));
		xslProc.addParameter("sco", unescape(m_sAliasSCOID));
		xslProc.addParameter("eventid", lEventID);
		xslProc.addParameter("framenum", lFrameID);
		xslProc.addParameter("aliasid", m_lEventID);
		xslProc.addParameter("fontstylecss", sFontStyleCSS);
		xslProc.addParameter("borderstylecss", sBorderStyleCSS);
		
		var sMergeContent = "";
		var sMergeFrameList = "";
		var sMergeLayout = "";
		
		//var objCurEvent = CP.m_arrEvents[String(m_lEventID)];
		var objCurEvent = xmlDoc.selectSingleNode("/SCO/EVENTS/*[@ID='" + lEventID + "']")
/*		
		if (xmlDoc.selectSingleNode("/SCO/CURRENT").attributes.getNamedItem("MERGECONTENT") != null) {
			CP.m_sMergeContent = xmlDoc.selectSingleNode("/SCO/CURRENT").attributes.getNamedItem("MERGECONTENT").value
		}
		if (xmlDoc.selectSingleNode("/SCO/CURRENT").attributes.getNamedItem("MERGEFRAMELIST") != null) {
			CP.m_sMergeFrameList = xmlDoc.selectSingleNode("/SCO/CURRENT").attributes.getNamedItem("MERGEFRAMELIST").value
		}
		if (xmlDoc.selectSingleNode("/SCO/CURRENT").attributes.getNamedItem("MERGELAYOUT") != null) {	
			CP.m_sMergeLayout = xmlDoc.selectSingleNode("/SCO/CURRENT").attributes.getNamedItem("MERGELAYOUT").value
		}	
		
		// Check if merging at local event level
		if (objCurEvent.attributes.getNamedItem("MERGECONTENT") != null) {
			if (objCurEvent.attributes.getNamedItem("MERGECONTENT").value != "") {
				sMergeContent = objCurEvent.attributes.getNamedItem("MERGECONTENT").value;
			}
		}
		// Check if merging at global sco level
		if (sMergeContent == "") {
			if (CP.m_sMergeContent != "") {
				sMergeContent = CP.m_sMergeContent;
			}
		}	
		
		// Check if merging at local event level
		if (objCurEvent.attributes.getNamedItem("MERGEFRAMELIST") != null) {
			if (objCurEvent.attributes.getNamedItem("MERGEFRAMELIST").value != "") {
				sMergeFrameList = objCurEvent.attributes.getNamedItem("MERGEFRAMELIST").value;
			}
		}
		// Check if merging at global sco level
		if (sMergeFrameList == "") {
			if (CP.m_sMergeFrameList != "") {
				sMergeFrameList = CP.m_sMergeFrameList;
			}
		}	

		// Check if merging at local event level
		if (objCurEvent.attributes.getNamedItem("MERGELAYOUT") != null) {
			if (objCurEvent.attributes.getNamedItem("MERGELAYOUT").value != "") {
				sMergeLayout = objCurEvent.attributes.getNamedItem("MERGELAYOUT").value;
			}
		}
		// Check if merging at global sco level
		if (sMergeLayout == "") {
			if (CP.m_sMergeLayout != "") {
				sMergeLayout = CP.m_sMergeLayout;
			}
		}	

		if (sMergeContent != "") {
			xslProc.addParameter("mergescocontent", sMergeContent);
		}
		if (sMergeFrameList != "") {
			xslProc.addParameter("mergeframelist", sMergeFrameList);
		}
		if (sMergeLayout != "") {
			xslProc.addParameter("mergelayout", sMergeLayout);
		}
*/		

		xslProc.addParameter("storyboardmode","false");

		xslProc.transform();
	}

	if (sTarget != null && sTarget != "") {
		var arrTargets = new Array();
		arrTargets = sTarget.split(";");
		
		var sFramesPath = "";
		
		sFramesPath = "parent.content";

		for (var i=0; i<arrTargets.length; i++) {
			sFramesPath = sFramesPath + ".frames['" + arrTargets[i] + "']";  
		}
		
		var oFramesPath;
		oFramesPath = eval(sFramesPath);
			
		if (sExternalURL != ""){
			oFramesPath.location.href = sExternalURL;
			return;
		}			
		
		if (m_bDynamic) {
			oFramesPath.parent.engine = parent.engine;
			oFramesPath.document.open();
			oFramesPath.document.write(xslProc.output);
			oFramesPath.document.close();
			if (sBMAnchor != ""){
				oFramesPath.document.location.href = "#" + sBMAnchor;
			}	
		} else {
			oFramesPath.parent.engine = parent.engine;
			
			if (sBMAnchor != ""){
				sBMAnchor = "#" + sBMAnchor;	
			}	
			
			var sTempSCOID = "";
			if (m_bPooledEvent == true){
				sFullFilename = replaceAll(replaceAll(m_sAliasSCOID,"/","-")," ","_") + "_" + sFullFilename;
				sTempSCOID = m_sAliasSCOID;
				m_sAliasSCOID = m_sSCOID;
			}		
			
			if (m_sContentDir == ".") {
				oFramesPath.location.href = sFullFilename + sBMAnchor;
			} else {
				oFramesPath.location.href = m_sContentDir + "/scos/" + replaceAll(replaceAll(replaceAll(m_sAliasSCOID,"%5c","/"),"%5C","/"),"%20"," ") + "/" + sFullFilename + sBMAnchor;
			}	
			
 			if (m_bPooledEvent == true){
				m_sAliasSCOID = sTempSCOID;
			}	

		}	
	} else {
		
		if (sExternalURL != ""){
			parent.content.location.href = sExternalURL;
			return;
		}	

		if (m_bDynamic) {
			parent.content.document.open();
			parent.content.document.write(xslProc.output);
			parent.content.document.close();
			if (sBMAnchor != ""){
				parent.content.document.location.href = "#" + sBMAnchor;
			}	

		} else {
			
			if (sBMAnchor != ""){
				sBMAnchor = "#" + sBMAnchor;	
			}
			var sTempSCOID = "";
			if (m_bPooledEvent == true){
				sFullFilename = replaceAll(replaceAll(m_sAliasSCOID,"/","-")," ","_") + "_" + sFullFilename;
				sTempSCOID = m_sAliasSCOID;
				m_sAliasSCOID = m_sSCOID;
			}		
			if (m_sContentDir == ".") {
				parent.content.location.href = sFullFilename + sBMAnchor;
			} else {
				parent.content.location.href = m_sContentDir + "/scos/" + replaceAll(replaceAll(replaceAll(m_sAliasSCOID,"%5c","/"),"%5C","/"),"%20"," ") + "/" + sFullFilename + sBMAnchor;
			}	
			if (m_bPooledEvent == true){
				m_sAliasSCOID = sTempSCOID;
			}	
		}	
	}	
}

function getID(srcElement) {
	if (srcElement == null) {
		return "";
	}
	if (srcElement.id != "" && srcElement.tagName.toLowerCase() == "div" && srcElement.id.indexOf('div_lbl_')==-1 && srcElement.id.indexOf('div_int_')==-1 && srcElement.id.indexOf('div_')>=0) {
		return srcElement.id;
	} else {
		return getID(srcElement.parentElement);
	}
}

function saveHistory(lEventID){
	var i = (m_arrHistoryNav.length-1) - m_nHistoryCurIdx;
	if(i > 0){
		for (i;i>0;i--){
			m_arrHistoryNav = arrPop(m_arrHistoryNav);	
		}	
	}
	m_arrHistoryNav = arrPush(m_arrHistoryNav,lEventID);
	m_nHistoryCurIdx++;
}	

function replaceAll(sStr,sFind,sReplace){
	if (sFind == "/"){
		rExp = /\//gi;
    } else if (sFind == "\\"){
		rExp = /\\/gi;
	}else{
		rExp = eval("/" + sFind + "/gi");
	}	
    
	myString = new String(sStr);
	results = myString.replace(rExp, sReplace);
	return results;
}	

function getTreeNavPos(){
	for (var i=0;i<arrTreeNav.length;i++){
		if (arrTreeNav[i]==m_lEventID){
			return i;
		}	
	}			
	return "";
}	

function unswapImages(){
	for (var i=0;i<aSwapImages.length;i++){
		if (aSwapImages[i].name != null){
			if (aSwapImages[i].window.document.getElementById(aSwapImages[i].name) != null){
				aSwapImages[i].window.document.getElementById(aSwapImages[i].name).src=aSwapImages[i].src;
			}	
		}			
	}		
}	
// End Non highlevel api used internally
