﻿function CAnimate(sEventID) {	
	if(sEventID == null || sEventID == '') {
		sEventID = m_lEventID;
	}
	this.eventID					=	sEventID;
	
	//-------------method declaration-----------------//
	this.autoAdvance										=	_autoAdvance;
	this.autoAdvanceGotoEvent						=	_autoAdvanceGotoEvent;
	this.autoAdvanceGotoEventAndFrame		=	_autoAdvanceGotoEventAndFrame;
	this.autoAdvanceGotoNextEvent				=	_autoAdvanceGotoNextEvent;
	this.autoAdvanceGotoPreviousEvent		=	_autoAdvanceGotoPreviousEvent;
	this.autoAdvanceGotoNextFrame				=	_autoAdvanceGotoNextFrame;	
	this.autoAdvanceGotoPreviousFrame		=	_autoAdvanceGotoPreviousFrame;
	
	
	//-------------method definition-----------------//
	function _autoAdvance(sFunctionName,timeout) {
		m_nTimeoutID = setTimeout(sFunctionName,parseInt(timeout));
		return m_nTimeoutID;
	}	

	function _autoAdvanceGotoEvent(lEventID,timeout) {  
		m_nTimeoutID = setTimeout('new CSCOStructure().gotoEvent(' + lEventID + ')',parseInt(timeout));
	}

	function _autoAdvanceGotoEventAndFrame(lEventID,lFrameID,timeout) {
		m_nTimeoutID = setTimeout('new CSCOStructure().gotoEventAndFrame(' + lEventID + ',' + lFrameID + ')',parseInt(timeout));
	}
	
	function _autoAdvanceGotoNextEvent(timeout) {  
		m_nTimeoutID = setTimeout('new CEvent(' + this.eventID + ').gotoNextEvent()',parseInt(timeout));
	}

	function _autoAdvanceGotoPreviousEvent(timeout) {
		m_nTimeoutID = setTimeout('new CEvent(' + this.eventID + ').gotoPreviousEvent()',parseInt(timeout));
	}
	
	function _autoAdvanceGotoNextFrame(timeout) {
		m_nTimeoutID = setTimeout('new CEvent(' + this.eventID + ').gotoNextFrame()',parseInt(timeout));
		return m_nTimeoutID;
	}
	
	function _autoAdvanceGotoPreviousFrame(timeout) {
		m_nTimeoutID = setTimeout('new CEvent(' + this.eventID + ').gotoPreviousFrame()',parseInt(timeout));
		return m_nTimeoutID;
	}	
	
	//--------------------------------------------------------//	
}			// class


