﻿function CAnimateFrameObject(targetwindow) {
	//-------------property declaration-----------------//
	if(targetwindow == null) {
		this.windowTarget						=	parent.content;
	} else {
		this.windowTarget						=	targetwindow;
	}


	//-------------method declaration-----------------//
	this.createAnimationGroup				= _createAnimationGroup;
	this.moveAnimationGroup					= _moveAnimationGroup;
	this.flyIn											= _flyIn;

/*
// new
	this.animateResizeObject				=	_animateResizeObject;
	this.animateResizeObjectRecurse	= _animateResizeObjectRecurse;
	*/

	//-------------method definition-----------------//
	function _createAnimationGroup(sFrameListObjects) {
		var arrFLObjects = sFrameListObjects.split(';');
		var arrAnimGroup = new Array(arrFLObjects.length);
		for (var i=0; i<arrFLObjects.length;i++) {
			arrAnimGroup[i] = new Array(3);
		}

		for (var i=0; i<arrFLObjects.length;i++) {
			arrAnimGroup[i][0] = arrFLObjects[i];
			arrAnimGroup[i][1] = this.windowTarget.document.getElementById("div_" + arrFLObjects[i]).offsetLeft;
			arrAnimGroup[i][2] = this.windowTarget.document.getElementById("div_" + arrFLObjects[i]).offsetTop;
			arrAnimGroup[i][3] = Number(this.windowTarget.document.getElementById("div_" + arrFLObjects[i]).style.width.replace("px",""));
			arrAnimGroup[i][4] = Number(this.windowTarget.document.getElementById("div_" + arrFLObjects[i]).style.height.replace("px",""));
		}

		return arrAnimGroup;
	}


	function _moveAnimationGroup(arrAnimGroup,x,y) {
		var offsetX = x-arrAnimGroup[0][1];
		var offsetY = y-arrAnimGroup[0][2];
		
		for (var i=0; i<arrAnimGroup.length;i++) {
			var oFrmObj = new CFrameObject(arrAnimGroup[i][0]);
			oFrmObj.moveObject(arrAnimGroup[i][1]+offsetX,arrAnimGroup[i][2]+offsetY);
		}
	}


	function _flyIn(arrAnimationGroup,nDuration,nStartingX,nStartingY,nEndingX,nEndingY,funcOnDoneMove){  
		nDuration = parseInt(nDuration);
		if (nStartingX != null && nStartingY != null){
			this.moveAnimationGroup(arrAnimationGroup,nStartingX,nStartingY);		
		}	

		if (nStartingX == null){
			nStartingX = -1000;
		}
		if (nStartingY == null){
			nStartingY = -1000;
		}


		//get the left and top most object in the group
		if (nEndingX == null || nEndingY == null){
			nEndingX = 50000;
			nEndingY = 50000;
			var xHold;
			var yHold;
			for (var i=0;i<arrAnimationGroup.length;i++){
				xHold = arrAnimationGroup[i][1];
				if (Number(xHold) < Number(nEndingX)){
					nEndingX = Number(xHold);
					var oEndX = arrAnimationGroup[i][0]; 
					
				}
				yHold = arrAnimationGroup[i][2]
				if (Number(yHold) < Number(nEndingY)){
					nEndingY = Number(yHold);
					var oEndY = arrAnimationGroup[i][0]; 	
				}
			}
		}else{
			for (var i=0;i<arrAnimationGroup.length;i++){
				xHold = arrAnimationGroup[i][1];
				if (Number(xHold) < Number(nEndingX)){
					var oEndX = arrAnimationGroup[i][0]; 	
				}
				yHold = arrAnimationGroup[i][2]
				if (Number(yHold) < Number(nEndingY)){
					var oEndY = arrAnimationGroup[i][0]; 	
				}
			}
		}

		var xDist = nEndingX - nStartingX;
		var yDist = nEndingY - nStartingY;

		var xtimes= (xDist/nDuration)*100;
		var ytimes= (yDist/nDuration)*100;
		var ntimes = xtimes;
		if (ytimes>ntimes){
			ntimes = ytimes;
		}

		var xpix = xDist/xtimes; 
		var ypix = yDist/ytimes;


		var curx = nStartingX;
		var cury = nStartingY;

		var nCnt = 1;
		var xStop = 0;
		var yStop = 0;

		this.moveAnimationGroup(arrAnimationGroup,curx,cury);
		var oFrmObj = new CFrameObject(oEndX,this.windowTarget);
		var nInter = setInterval(function(){if(Number(new CFrameObject(oEndX,this.windowTarget).getFrameObjectElement().style.left.replace("px",""))< nEndingX){curx=curx+nDuration}else{xStop++};if(Number(new CFrameObject(oEndY,this.windowTarget).getFrameObjectElement().style.top.replace("px",""))< nEndingY){cury=cury+nDuration}else{yStop++};if(xStop>0&&yStop>0){clearInterval(nInter);new CAnimateFrameObject(this.windowTarget).moveAnimationGroup(arrAnimationGroup,nEndingX,nEndingY);eval(funcOnDoneMove)};new CAnimateFrameObject(this.windowTarget).moveAnimationGroup(arrAnimationGroup,curx,cury);},100);

		m_arrAnimationInterval[m_arrAnimationInterval.length+1] = nInter;
	}

/*
// new
	function _animateResizeObject(sFrameObjectName,startX,startY,startWidth,startHeight,endX,endY,endWidth,endHeight,duration,refreshRate,fnc) {
	  this.animateResizeObjectRecurse(sFrameObjectName,startX,startY,startWidth,startHeight,endX,endY,endWidth,endHeight,duration,refreshRate,fnc);
	}
	
	function _animateResizeObjectRecurse(sFrameObjectName,startX,startY,startWidth,startHeight,endX,endY,endWidth,endHeight,duration,refreshRate,fnc) {
	  new CFrameObject(sFrameObjectName,this.windowTarget).resizeFrameObject(startX,startY,startWidth,startHeight);
	
	  var newPosX = startX + (endX-startX)*(refreshRate/duration);
	  var newPosY = startY + (endY-startY)*(refreshRate/duration);
	  var newPosWidth = startWidth + (endWidth-startWidth)*(refreshRate/duration);
	  var newPosHeight = startHeight + (endHeight-startHeight)*(refreshRate/duration);
	
	  if ((duration-refreshRate) > 0) {
	    timerID = setTimeout(function(){new CAnimateFrameObject().animateResizeObjectRecurse(sFrameObjectName,newPosX,newPosY,newPosWidth,newPosHeight,endX,endY,endWidth,endHeight,(duration-refreshRate),refreshRate,fnc);},refreshRate);
	  } else {
	    new CFrameObject(sFrameObjectName,this.windowTarget).resizeFrameObject(endX,endY,endWidth,endHeight);
	    fnc;
	  }
	}
*/

	//--------------------------------------------------------//

}		// class