﻿function CAnimateLayer(targetwindow) {
	//-------------property declaration-----------------//
	if(targetwindow == null) {
		this.windowTarget						=	parent.content;
	} else {
		this.windowTarget						=	targetwindow;
	}	
	
	//-------------class inheritance-----------------//
	var oAnimFrmObj				= new CAnimateFrameObject(this.windowTarget);

	
	//-------------method declaration-----------------//
	this.createAnimationGroupFromLayer		=	_createAnimationGroupFromLayer;
	this.moveAnimationLayer								=	_moveAnimationLayer;
	this.flyInLayerFromLeft								=	_flyInLayerFromLeft;
	this.flyInLayerFromRight							=	_flyInLayerFromRight;
	this.flyInLayerFromTop								=	_flyInLayerFromTop;
	this.flyInLayerFromBottom							=	_flyInLayerFromBottom;
	
/*
	// new
	this.moveLayerByName									=	_moveLayerByName;
	this.animateMoveLayerRecurse					=	_animateMoveLayerRecurse;
	// new - till here
*/

	//-------------method definition-----------------//
	function _createAnimationGroupFromLayer(sLayerName) {
		var objLayer = new CLayer(sLayerName);
		var sFrameListObjects = objLayer.getObjects();
		return oAnimFrmObj.createAnimationGroup(sFrameListObjects);
	}	


	function _moveAnimationLayer(arrAnimGroup,x,y) {
		var nEndingX = 50000;
		var nEndingY = 50000;
		for (var i=0;i<arrAnimGroup.length;i++){
			if (Number(arrAnimGroup[i][1]) < Number(nEndingX)){
				nEndingX = Number(arrAnimGroup[i][1]);
			}
			if (Number(arrAnimGroup[i][2]) < Number(nEndingY)){
				nEndingY = Number(arrAnimGroup[i][2]);
			}
		}

		var offsetX = x-nEndingX;
		var offsetY = y-nEndingY;
		
		for (var i=0; i<arrAnimGroup.length;i++) {
			var oFrameObj = new CFrameObject(arrAnimGroup[i][0]);
			oFrameObj.moveObject(arrAnimGroup[i][1]+offsetX,arrAnimGroup[i][2]+offsetY);
		}
	}


	function _flyInLayerFromLeft(sLayerName,nSpeed,funcOnDoneMove,nStartX){
		nSpeed = parseInt(nSpeed);
		var animationGroup = this.createAnimationGroupFromLayer(sLayerName);

		var nEndingX = 50000;
		var nEndingY = 50000;
		var nLayerWidth = 0;
		for (var i=0;i<animationGroup.length;i++){
			if (Number(animationGroup[i][1]) < Number(nEndingX)){
				var oEndX = animationGroup[i][0]; 
				nEndingX = Number(animationGroup[i][1]);
			}
			if (Number(animationGroup[i][2]) < Number(nEndingY)){
				var oEndY = animationGroup[i][0]; 
				nEndingY = Number(animationGroup[i][2]);	
			}
			if (Number(animationGroup[i][1] + animationGroup[i][3]) > nLayerWidth){
				nLayerWidth = Number(animationGroup[i][1] + animationGroup[i][3]);	
			}
		}
		
		var xStop = 0;
		var yStop = 0;
		if (nStartX == "" || nStartX == null){
			var curx = eval(-nLayerWidth);
		}else{
			var curx = Number(nStartX);
		}
		var cury = nEndingY;
		this.moveAnimationLayer(animationGroup,curx,cury);
		var nInter = setInterval(function(){if (Number(new CFrameObject(oEndX,this.windowTarget).getFrameObjectElement().style.left.replace("px",""))+nSpeed< nEndingX){curx=curx+nSpeed}else{xStop++};if(xStop>0){clearInterval(nInter);curx=nEndingX;cury=nEndingY;eval(funcOnDoneMove);};new CAnimateLayer(this.windowTarget).moveAnimationLayer(animationGroup,curx,cury);},100);	
		m_arrAnimationInterval[m_arrAnimationInterval.length+1] = nInter;	
	}


	function _flyInLayerFromRight(sLayerName,nSpeed,funcOnDoneMove,nStartX){
		nSpeed = parseInt(nSpeed);
		var animationGroup = this.createAnimationGroupFromLayer(sLayerName);

		var nEndingX = 50000;
		var nEndingY = 50000;
		var nLayerWidth = 0;
		for (var i=0;i<animationGroup.length;i++){
			if (Number(animationGroup[i][1]) < Number(nEndingX)){
				var oEndX = animationGroup[i][0]; 
				nEndingX = Number(animationGroup[i][1]);
				nLayerWidth = nEndingX;
			}
			if (Number(animationGroup[i][2]) < Number(nEndingY)){
				var oEndY = animationGroup[i][0]; 
				nEndingY = Number(animationGroup[i][2]);	
			}
		}
		
		var xStop = 0;
		var yStop = 0;
		nLayerWidth = nLayerWidth + screen.width;
		if (nStartX == "" || nStartX == null){
			var curx = nLayerWidth;
		}else{
			var curx = Number(nStartX);
		}	
		var cury = nEndingY;
		this.moveAnimationLayer(animationGroup,curx,cury);
		var nInter = setInterval(function(){if (Number(new CFrameObject(oEndX).getFrameObjectElement().style.left.replace("px",""))-nSpeed> nEndingX){curx=curx-nSpeed}else{xStop++};if(xStop>0){clearInterval(nInter);curx=nEndingX;cury=nEndingY;eval(funcOnDoneMove);};new CAnimateLayer(this.windowTarget).moveAnimationLayer(animationGroup,curx,cury);},100);	
		m_arrAnimationInterval[m_arrAnimationInterval.length+1] = nInter;	
	}


	function _flyInLayerFromTop(sLayerName,nSpeed,funcOnDoneMove,nStartY){
		nSpeed = parseInt(nSpeed);
		var animationGroup = this.createAnimationGroupFromLayer(sLayerName);

		var nEndingX = 50000;
		var nEndingY = 50000;
		var nLayerWidth = 0;
		for (var i=0;i<animationGroup.length;i++){
			if (Number(animationGroup[i][1]) < Number(nEndingX)){
				var oEndX = animationGroup[i][0]; 
				nEndingX = Number(animationGroup[i][1]);
				nLayerWidth = nEndingX;
			}
			if (Number(animationGroup[i][2]) < Number(nEndingY)){
				var oEndY = animationGroup[i][0]; 
				nEndingY = Number(animationGroup[i][2]);	
			}
			if (Number(animationGroup[i][2] + animationGroup[i][4]) > nLayerWidth){
				nLayerWidth = Number(animationGroup[i][2] + animationGroup[i][4]);	
			}
		}
		
		var xStop = 0;
		var yStop = 0;
		if (nStartY == "" || nStartY == null){
			var cury = eval(-nLayerWidth);
		}else{
			var cury = Number(nStartY);
		}
		var curx = nEndingX;
		this.moveAnimationLayer(animationGroup,curx,cury);
		var nInter = setInterval(function(){if (Number(new CFrameObject(oEndY).getFrameObjectElement().style.top.replace("px",""))+nSpeed< nEndingY){cury=cury+nSpeed}else{yStop++};if(yStop>0){clearInterval(nInter);cury=nEndingY;curx=nEndingX;eval(funcOnDoneMove);};new CAnimateLayer(this.windowTarget).moveAnimationLayer(animationGroup,curx,cury);},100);	
		m_arrAnimationInterval[m_arrAnimationInterval.length+1] = nInter;
	}


	function _flyInLayerFromBottom(sLayerName,nSpeed,funcOnDoneMove,nStartY) {
		nSpeed = parseInt(nSpeed);
		var animationGroup = this.createAnimationGroupFromLayer(sLayerName);

		var nEndingX = 50000;
		var nEndingY = 50000;
		var nLayerWidth = 0;
		for (var i=0;i<animationGroup.length;i++){
			if (Number(animationGroup[i][1]) < Number(nEndingX)){
				var oEndX = animationGroup[i][0]; 
				nEndingX = Number(animationGroup[i][1]);
			}
			if (Number(animationGroup[i][2]) < Number(nEndingY)){
				var oEndY = animationGroup[i][0]; 
				nEndingY = Number(animationGroup[i][2]);	
				//nLayerWidth = nEndingY;
			}

		}
		nLayerWidth = screen.height;	
		var xStop = 0;
		var yStop = 0;
		if (nStartY == "" || nStartY == null){
			var cury = nLayerWidth;
		}else{
			var cury = Number(nStartY);
		}
		var curx = nEndingX;
		this.moveAnimationLayer(animationGroup,curx,cury);
		var nInter = setInterval(function(){if (Number(new CFrameObject(oEndY).getFrameObjectElement().style.top.replace("px",""))-nSpeed> nEndingY){cury=cury-nSpeed}else{yStop++};if(yStop>0){clearInterval(nInter);cury=nEndingY;curx=nEndingX;eval(funcOnDoneMove);};new CAnimateLayer(this.windowTarget).moveAnimationLayer(animationGroup,curx,cury);},100);	
		m_arrAnimationInterval[m_arrAnimationInterval.length+1] = nInter;
	}

//new 
/*
	function _moveLayerByName(sLayerName,startX,startY,endX,endY,duration,refreshRate,fnc) {	
	  var m_amn = null;
	  m_anm = new Array();
	  m_anm = this.createAnimationGroupFromLayer(sLayerName);
	  
	  var objPosForLayer = new CLayer(sLayerName,this.windowTarget).getPositionAndSizeForLayer();
	  var objPosFirstAnim = new CFrameObject(m_anm[0][0],this.windowTarget).getPositionAndSize();
	  
	  var nDeltaX = objPosForLayer.left - objPosFirstAnim.left;
	  var nDeltaY = objPosForLayer.top - objPosFirstAnim.top;
	
	  this.animateMoveLayerRecurse(m_anm,startX-nDeltaX,startY-nDeltaY,endX-nDeltaX,endY-nDeltaY,duration,refreshRate,fnc);
	}
	
	function _animateMoveLayerRecurse(sAnimGroup,startX,startY,endX,endY,duration,refreshRate,fnc) {
	  this.moveAnimationLayer(sAnimGroup,startX,startY);
	
	  var newPosX = startX + (endX-startX)*(refreshRate/duration);
	  var newPosY = startY + (endY-startY)*(refreshRate/duration);
	
	  if ((duration-refreshRate) > 0) {
	    timerID = setTimeout(function() {this.animateMoveLayerRecurse(newPosX,newPosY,endX,endY,(duration-refreshRate),refreshRate,fnc);},refreshRate);
	  } else {
	    this.moveAnimationLayer(sAnimGroup,endX,endY);
	    // Call the callback function
	    fnc();
	  }
	}	

function animateMoveLayerCallback() {
     var objPosAndSize = new CFrameObject().getPositionAndSize("img_1");
    new CAnimateFrameObject().animateResizeObject("img_1",objPosAndSize.left,objPosAndSize.top,0,0,objPosAndSize.left,objPosAndSize.top,objPosAndSize.width,objPosAndSize.height,300,1000/m_nFPS,animateResizeObjectCallback);
    
    CP.ShowLayer("Slides Bubble");
}*/


	//--------------------------------------------------------//
}		// class