﻿var m_arrExpandIcon = new Array();
var m_arrFolderIcon = new Array();
var m_arrEventIcon = new Array();
var m_arrCompletionIcon = new Array();
var m_arrTreeBorderStyle = new Array();
var m_arrNodeItemObj = new Array();
var m_arrTreeItems = new Array();
var m_arrTreeItemLevelWidth = new Array();
var m_arrTrees = new Array();
var m_arrExpandIconOrder = new Array();
var m_arrNodeIconOrder = new Array();
var m_arrCompletionIconOrder = new Array();
var m_arrNodeItemObjOrder = new Array();
var m_arrNodeIndent = new Array();
var m_bHideEvents = false;

function CBuildTree(sTreeName,targetengine,targetwindow) {
	this.treeName 			 = sTreeName;
	this.windowTarget		 = targetwindow;
	this.targetEngine		 = targetengine;
	this.getExistingTree = _getExistingTree;
	
	function _getExistingTree() {
		return GetExistingTree(this.treeName,this.targetEngine,this.windowTarget);
	}
}


function PopulateCPTree(oTree){
	if (arguments[1] != null){
		var id = arguments[2];
		var stype = arguments[1];
		if (stype == "1"){
			oTopNode = recurseTreeBuild(m_arrEvents[id],null,oTree);
		}else{
			oTopNode = recurseTreeBuild(m_arrNavs[id],null,oTree);
		}	
	}else{	
		oTopNode = recurseTreeBuild(m_arrNavs["1"],null,oTree);
	}
	oTree.appendChild(oTopNode);
	return oTree;
}

function recurseTreeBuild(oNode,oTreeParent,oTree){
	var bVisible = false;
	
	
	
	if (oNode.COURSEMAPBEHAVIOR == "" || oNode.COURSEMAPBEHAVIOR == "None" || oNode.COURSEMAPBEHAVIOR == null || oNode.COURSEMAPBEHAVIOR == "Hide Children"){
		bVisible = true;
				
		var sID = "";
		if (oNode.TYPE != null){
			sID = oTree.id + "_Event_" + oNode.ID;
		}else{
			sID = oTree.id + "_Nav_" + oNode.ID;
		}
		var oTreeItem = new TreeItem(sID,oTreeParent);
		var iLevel = getLevel(oTreeItem);
		oTreeItem.setLevel(iLevel);			
		m_arrTreeItems[sID] = oTreeItem;
		
		//Set Tree Name
		oTreeItem.treeName = "CP.m_arrTrees[\"" + oTree.id + "\"]";
		
		// Set Node Item Object
		var oNodeItemObj = null;
		if (m_arrNodeItemObj[iLevel] != null){
			oNodeItemObj = new NodeItemObj();	
			oNodeItemObj.setBorderStyle(m_arrNodeItemObj[iLevel].borderStyle);
			oNodeItemObj.setFontStyle(m_arrNodeItemObj[iLevel].fontStyle);
			oNodeItemObj.setImage(m_arrNodeItemObj[iLevel].image);
			oNodeItemObj.setCaptionAlign(m_arrNodeItemObj[iLevel].captionAlign);
			oNodeItemObj.setCaptionPadding(m_arrNodeItemObj[iLevel].captionPadLeft,m_arrNodeItemObj[iLevel].captionPadRight,m_arrNodeItemObj[iLevel].captionPadTop,m_arrNodeItemObj[iLevel].captionPadBottom);			
			oNodeItemObj.setItemHeight(m_arrNodeItemObj[iLevel].itemHeight);
			oNodeItemObj.setItemWidth(m_arrNodeItemObj[iLevel].itemWidth);
		}	
		oTreeItem.setNodeItemObj(oNodeItemObj);
		
		// set Text
		if (oNode.ALIASNAME != null){
			oTreeItem.nodeItemObj.setText(oNode.ALIASNAME);
		}else{
			oTreeItem.nodeItemObj.setText(oNode.NAME);
		}
		
		
		
		//set Image
		//oTreeItem.setNodeImage(m_oNodeImage);
		
		//set Icons
		var oFolderIcon = null;
		var oExpandIcon = null;
		var oEventIcon = null;
		var oCompletionIcon = null;
		
		if (m_arrFolderIcon[iLevel] != null){
			oFolderIcon = new FolderIcon();
			oFolderIcon.setOpenIcon(m_arrFolderIcon[iLevel].openIcon);
			oFolderIcon.setClosedIcon(m_arrFolderIcon[iLevel].closedIcon);
			oFolderIcon.setBorderStyle(m_arrFolderIcon[iLevel].borderStyle);
		}

		if (m_arrExpandIcon[iLevel] != null){
			oExpandIcon = new ExpandIcon();
			oExpandIcon.setExpandedIcon(m_arrExpandIcon[iLevel].expandedIcon);
			oExpandIcon.setCollapsedIcon(m_arrExpandIcon[iLevel].collapsedIcon);
			oExpandIcon.setBorderStyle(m_arrExpandIcon[iLevel].borderStyle);
		}	
		
		if (m_arrEventIcon[iLevel] != null){
			oEventIcon = new EventIcon();
			if (m_arrEventIcon[iLevel].state1Icon != ""){
				oEventIcon.setState1Icon(m_arrEventIcon[iLevel].state1Icon);
			}	
			if (m_arrEventIcon[iLevel].state2Icon != ""){
				oEventIcon.setState2Icon(m_arrEventIcon[iLevel].state2Icon);
			}
			if (m_arrEventIcon[iLevel].state3Icon != ""){
				oEventIcon.setState3Icon(m_arrEventIcon[iLevel].state3Icon);
			}
			oEventIcon.setBorderStyle(m_arrEventIcon[iLevel].borderStyle);
		}	
		
		if (m_arrCompletionIcon[iLevel] != null){
			oCompletionIcon = new CompletionIcon();
			oCompletionIcon.setNotStartedIcon(m_arrCompletionIcon[iLevel].notStartedIcon);
			oCompletionIcon.setStartedIcon(m_arrCompletionIcon[iLevel].startedIcon);
			oCompletionIcon.setCompletedIcon(m_arrCompletionIcon[iLevel].completedIcon);
			oCompletionIcon.setBorderStyle(m_arrCompletionIcon[iLevel].borderStyle);
		}	
		
		if (oNode.children.length>0){
			if (oFolderIcon != null){
				oTreeItem.setNodeIcon(oFolderIcon);
			}	
		}else{
			if (oEventIcon != null){
				oTreeItem.setNodeIcon(oEventIcon);
			}	
		}
		oTreeItem.setExpandIcon(oExpandIcon);
		oTreeItem.setCompletionIcon(oCompletionIcon);
		
		//set Border
		oTreeItem.setBorderStyle(m_arrTreeBorderStyle[iLevel]);
		
		//set width
		if (m_arrTreeItemLevelWidth[iLevel] != null){
			oTreeItem.setWidth(m_arrTreeItemLevelWidth[iLevel]);	
		}
		
		// setIndent
		if (m_arrNodeIndent[iLevel] != ""){
			oTreeItem.setIndent(m_arrNodeIndent[iLevel]);
		}	
						
		//set data
		oTreeItem.setData(oNode);
		
		//set item row order
		if (oCompletionIcon != null){
			oTreeItem.setCompletionIconOrder(m_arrCompletionIconOrder[iLevel]);
		}
		if (oExpandIcon != null){	
			oTreeItem.setExpandIconOrder(m_arrExpandIconOrder[iLevel]);
		}	
		if (oTreeItem.nodeIconObj != null){
			oTreeItem.setNodeIconOrder(m_arrNodeIconOrder[iLevel]);
		}
		if (oTreeItem.nodeItemObj != null){	
			oTreeItem.setNodeItemObjOrder(m_arrNodeItemObjOrder[iLevel]);
		}	
		
		
	}
	if (oNode.firstChild() != null){
		if (oNode.firstChild().TYPE != null){
			if (m_bHideEvents == true){
				oNode.COURSEMAPBEHAVIOR = "Hide Children";
			}	
		}
	}
	if (oNode.COURSEMAPBEHAVIOR == "Hide Me and Children" || oNode.COURSEMAPBEHAVIOR == "Hide Children"){  
	}else{
		for (var i=0;i<oNode.children.length;i++){
			if (bVisible == true){
				var oChild = recurseTreeBuild(oNode.children[i],oTreeItem,oTree);
				if (oChild != null){
					oTreeItem.appendChild(oChild);
				}
			}else{
				var oChild = recurseTreeBuild(oNode.children[i],oTreeParent,oTree);
				if (oChild != null){
					if (oTreeParent != null){
						oTreeParent.appendChild(oChild);
					}	
				}
			}	
				
		}	
	}	
	return oTreeItem;
}

function CreateTree(sTreeName,sStartingType,sStartingID,targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}	
	var oTree = new JSTree(sTreeName,targetwindow);
	m_arrTrees[sTreeName] = oTree;
	return PopulateCPTree(oTree,sStartingType,sStartingID);
}
/*
function GetDefaultCPTree(targetwindow){
	
	setTreeLevelFolderIcon(m_sContentDir + "/media/core/images/open.gif",m_sContentDir + "/media/core/images/closed.gif");
	setTreeLevelExpandIcon(m_sContentDir + "/media/core/images/minus.gif",m_sContentDir + "/media/core/images/plus.gif");
	setTreeLevelEventIcon(m_sContentDir + "/media/core/images/doc.gif");
	setTreeLevelCompletionIcon(m_sContentDir + "/media/core/images/notstarted.gif",m_sContentDir + "/media/core/images/started.gif",m_sContentDir + "/media/core/images/completed.gif");
	return GetCPTree("CPTree",targetwindow);
	
}
*/	

function GetSubCPTree(sTreeName,sBeginingType,sBeginningID,targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
	if (typeof targetwindow == "string"){
		targetwindow = eval(targetwindow);
	}	
	var oTree = CreateTree(sTreeName,sBeginingType,sBeginningID,targetwindow);
	oTree.setNodeClickFunc(StandardNodeClick);
	oTree.setOnMouseOverFunc(myNodeOnMouseOver);
	oTree.setOnMouseOutFunc(myNodeOnMouseOut("out"));
	var sStr = oTree.drawTree();
	oTree.children[0].setExpanded(true);
	return sStr;
	
}

function GetExistingTree(sTreeName,targetengine,targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
	if (targetengine == null){
		targetengine = parent.engine;
	}	
	
	m_arrTrees = targetengine.m_arrTrees;
	m_arrTrees[sTreeName].targetwindow = targetwindow;
	
	if (m_arrTrees[sTreeName]==null){
		return "Course Tree (" + sTreeName + ") not initialized. Make sure that you have created a course tree with the same name.";
	}	
	var sVal = m_arrTrees[sTreeName].drawTree();
	return sVal;
}		
	
function GetCPTree(sTreeName,targetwindow){
	
	return GetSubCPTree(sTreeName,2,1,targetwindow);
	
}	

function StandardNodeClick(){
	if (arguments[0].id.indexOf("_Event_") != -1){
		new CSCOStructure().gotoEvent(arguments[0].data.ID);
	}else{
		if (arguments[0].data.COURSEMAPBEHAVIOR == "Hide Children"){
			if (arguments[0].data.children[0] != null){
				new CSCOStructure().gotoEvent(arguments[0].data.children[0].ID);
			}	
		}			
	}
}	


function RefreshCourseTree(){
	for (var oItem in m_arrTrees){
		var sTreeName = m_arrTrees[oItem].id;
		if (m_arrTreeItems[sTreeName + "_Event_" + m_lEventID] != null){
			m_arrTrees[sTreeName].expandTreeToID(sTreeName + "_Event_" +m_lEventID);
			eval(m_arrTrees[sTreeName].id + "_Hilite(m_arrTreeItems['" + sTreeName + "_Event_" + m_lEventID +"']);")	
		}else{
			var oStructNode = m_arrEvents[m_lEventID];
			var oRefreshNode = null; //m_arrTreeItems[sTreeName + "_Nav_" + + oStructNode.ID];
			while (oRefreshNode == null){
				oStructNode = oStructNode.parent;
				if (oStructNode == null){break;}
				if (oStructNode.arrFrames != null){
					oRefreshNode = m_arrTreeItems[sTreeName + "_Event_" + oStructNode.ID];
				}else{
					oRefreshNode = m_arrTreeItems[sTreeName + "_Nav_" + oStructNode.ID];
				}	
			}
			if (oStructNode != null){	
				m_arrTrees[sTreeName].expandTreeToID(sTreeName + "_Nav_" + oStructNode.ID);
				eval(m_arrTrees[sTreeName].id + "_Hilite(m_arrTreeItems['" + sTreeName + "_Nav_" + oStructNode.ID +"']);")	
			}	
		}	
	}		
}	

function hiliteNodeBorderStyle(sStyle){
	for (var oItem in m_arrTrees){
		var sTreeName = m_arrTrees[oItem].id;
		sStyle = replaceAll(replaceAll(sStyle,"\\","-")," ","_");
		parent.content.document.getElementById("Row_" + sTreeName + "_Event_" + m_lEventID).className = sStyle;
	}	
}
function hiliteNodeFontStyle(sStyle){
	for (var oItem in m_arrTrees){
		var sTreeName = m_arrTrees[oItem].id;
		sStyle = replaceAll(replaceAll(sStyle,"\\","-")," ","_");
		parent.content.document.getElementById("Text_" + sTreeName + "_Event_" + m_lEventID).className = sStyle;
	}
}	
function hiliteNodeChangeImage(sImgName,sImgPath){
	for (var oItem in m_arrTrees){
		var sTreeName = m_arrTrees[oItem].id;
		sStyle = replaceAll(replaceAll(sStyle,"\\","-")," ","_");
		parent.content.document.getElementById(sImgName + "_" + sTreeName + "_Event_" + m_lEventID).src = sImgPath;
	}
}


function setTreeLevelEventIcon(sBorderStyle,sState1,sState2,sState3,nLevel){
	m_arrEventIcon[nLevel] = new EventIcon();
	m_arrEventIcon[nLevel].setState1Icon(sState1);
	m_arrEventIcon[nLevel].setState2Icon(sState2);
	m_arrEventIcon[nLevel].setState3Icon(sState3);
	m_arrEventIcon[nLevel].setBorderStyle(sBorderStyle);
}

function setTreeLevelNodeImage(sPath, sState){
	m_oNodeImage = new NodeImage();
	if (sState == null){
		m_oNodeImage.setState1Image(sPath);
	}else{
		eval("m_oNodeImage.set" + sState + "Image('" + sPath + "')");
	}	
}

function setTreeLevelNodeIndent(sIndent,nLevel){
	m_arrNodeIndent[nLevel] = sIndent;
}	

function setTreeLevelExpandIcon(sBorderStyle,sExpandedIcon,sCollapsedIcon,nLevel){
	m_arrExpandIcon[nLevel] = new ExpandIcon();
	m_arrExpandIcon[nLevel].setExpandedIcon(sExpandedIcon);
	m_arrExpandIcon[nLevel].setCollapsedIcon(sCollapsedIcon);
	m_arrExpandIcon[nLevel].setBorderStyle(sBorderStyle);
}	

function setTreeLevelFolderIcon(sBorderStyle,sOpenIcon,sClosedIcon,nLevel){
	m_arrFolderIcon[nLevel] = new FolderIcon();
	m_arrFolderIcon[nLevel].setOpenIcon(sOpenIcon);
	m_arrFolderIcon[nLevel].setClosedIcon(sClosedIcon);
	m_arrFolderIcon[nLevel].setBorderStyle(sBorderStyle);
}

function setTreeLevelCompletionIcon(sBorderStyle,sNotStartedIcon,sStartedIcon,sCompletedIcon,nLevel){
	m_arrCompletionIcon[nLevel] = new CompletionIcon();
	m_arrCompletionIcon[nLevel].setNotStartedIcon(sNotStartedIcon);
	m_arrCompletionIcon[nLevel].setStartedIcon(sStartedIcon);
	m_arrCompletionIcon[nLevel].setCompletedIcon(sCompletedIcon);
	m_arrCompletionIcon[nLevel].setBorderStyle(sBorderStyle);
}


function setTreeLevelNodeItemObj(sFontStyle,sBorderStyle,sImage,sAlign,sPadLeft,sPadRight,sPadTop,sPadBottom,sWidth,sHeight,nLevel){
	m_arrNodeItemObj[nLevel] = new NodeItemObj();
	m_arrNodeItemObj[nLevel].setBorderStyle(sBorderStyle);
	m_arrNodeItemObj[nLevel].setFontStyle(sFontStyle);
	m_arrNodeItemObj[nLevel].setImage(sImage);
	m_arrNodeItemObj[nLevel].setCaptionAlign(sAlign);
	m_arrNodeItemObj[nLevel].setCaptionPadding(sPadLeft,sPadRight,sPadTop,sPadBottom);
	m_arrNodeItemObj[nLevel].setItemHeight(sHeight);
	m_arrNodeItemObj[nLevel].setItemWidth(sWidth);
}

function setTreeLevelBorderStyle(sBorderName,nLevel){
	sBorderName = replaceAll(replaceAll(sBorderName,"/","-")," ","_");
	m_arrTreeBorderStyle[nLevel] = "border_" + sBorderName;
}

function setTreeItemLevelWidth(sWidth,nLevel){
	m_arrTreeItemLevelWidth[nLevel] = sWidth;
}

function setTreeItemGlobalIndent(sIndent){
	m_sTreeItemGlobalIndent = sIndent;
}

function myNodeOnMouseOver(){
	var treeName = arguments[0].id.split("_")[1];
	alert(treeName);
}	

function myNodeOnMouseOut(){
/*	
	var id = replaceAll(arguments[0].id,"Row","Text");
	arguments[0].document.getElementById(id).className = "font_core-cp2-paragraph";
	arguments[0].document.getElementById(arguments[0].id).className = "border_core-cp2-event_description";
*/	
}	

function getLevel(oNode){
	var nlevel = 1;
	var oParentNode;
	oParentNode = oNode.parentNode;
	while (oParentNode != null){
		nlevel++;
		oParentNode = oParentNode.parentNode;
	}
	if (nlevel > 4){
		nlevel = 4;
	}	
	return nlevel;
}	