﻿function CImage(sImageObject,targetwindow) {
	//-------------property declaration-----------------//
	initialize();
	
	this.imageObject									=	sImageObject;
	
	if(targetwindow == null) {
		this.windowTarget							=	parent.content;
	} else {
		this.windowTarget							=	targetwindow;
	}


	//------------class inheritance and frame object validation----------//
	var objUtil												= new CUtil();
	var objFrameObject	 							=	new CFrameObject(this.imageObject,this.windowTarget);
	this.isFrameObjectExists					=	objFrameObject.isFrameObjectExists();
	
	if(this.windowTarget.arrContent[this.imageObject] != null) {
		this.alphaTransparency						=	this.windowTarget.arrContent[this.imageObject].ALPHATRANSPARENCY;
		this.delta												= this.windowTarget.arrContent[this.imageObject].DELTA;
	}

	//-------------method declaration-----------------//
	this.setImage											=	_setImage;
	this.getImage											=	_getImage;
	this.getAlphaTransparency					=	_getAlphaTransparency;
	this.getDelta											=	_getDelta;		

	//------------methods from class inheritance-----------//
	this.getVisibility							=	function() 									{return objFrameObject.getVisibility() };
	this.setVisibility							=	function(sState) 						{objFrameObject.setVisibility(sState) };
	this.getObjectZIndex						=	function() 									{return objFrameObject.getObjectZIndex() };
	this.setObjectZIndex						=	function(nZIndex) 					{objFrameObject.setObjectZIndex(nZIndex) };	
	this.moveObject									=	function(x,y) 							{return objFrameObject.moveObject(x,y) };
	this.resizeFrameObject					=	function(x,y,width,height)	{return objFrameObject.resizeFrameObject(x,y,width,height) };
	this.getLayerNameForObject			=	function() 									{return objFrameObject.getLayerNameForObject() };
	this.getPositionAndSize					= function()									{return objFrameObject.getPositionAndSize() };		
	
	//-------------method definition-----------------//
	function initialize() {
		if(sImageObject == '[object]') {
			sImageObject =	new CFrameObject(sImageObject).getCurrentFrameObjectName();
		}
	}	
	
	function _setImage(sSrc) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.imageObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_" + this.imageObject);
		if (obj != null) {
			obj.firstChild.src = m_sContentDir + "/media/" + sSrc;
		}
	}	


	function _getImage() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.imageObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_" + this.imageObject);
		if (obj != null) {
			return unescape(obj.firstChild.src.replace("file:///",""));
		} else {
			if(m_debug == true) {
				alert("Error! The object " + this.imageObject + " doesn't exist.");
			}
			return "";
		}	
	}


	function _getAlphaTransparency() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.imageObject);
		}		
		
		return this.alphaTransparency;
	}
	
	function _getDelta() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.imageObject);
		}		
		
		return this.delta;
	}
	

	//--------------------------------------------------------//

}			//class