﻿function CSCOStructure(sNavID,targetwindow) {
	this.initialize						=	_initialize;
	
	this.initialize();

	//-------------property declaration-------------//
	this.id										=	sNavID;
	this.parentEngine					= parent.engine;
	
	if(m_arrNavs[this.id] != null) {
		this.name									=	m_arrNavs[this.id].NAME;
		this.aliasName						=	m_arrNavs[this.id].ALIASNAME;
		this.hideInCourseMap			=	m_arrNavs[this.id].HIDEINCOURSEMAP;	
		
		this.parent								= m_arrNavs[this.id].parent;
		this.children							= m_arrNavs[this.id].children;
		this.next									= m_arrNavs[this.id].next;
		this.previous							= m_arrNavs[this.id].previous;
		this.firstChild						= m_arrNavs[this.id].firstChild();
		this.hasChildren					= m_arrNavs[this.id].hasChildren;
	}
	
	if(targetwindow == null) {
		this.windowTarget							=	parent.content;
	} else {
		this.windowTarget							=	targetwindow;
	}

	// highlevelapi - for course map
	this.sOpenFolder =  "media/core/images/open.gif";
	this.sClosedFolder =  "media/core/images/closed.gif";
	this.sInstructions= "The Course Map is a map of your entire course structure. Click on a folder to expand that node in the hierarchy. Events in the course can be navigated to by clicking on the name of the event that is underlined.";
	this.sEventIcon= "media/core/images/doc.gif";
	this.sHighliteEventIcon= "media/core/images/doc_h.gif";
	this.sCurrentNode="";
	this.nVerticalSpacing = "";
	this.nIndentSpacing = "margin-left: 16px;";

		
	//-------------method declaration-----------------//
	this.getAnimation					=	_getAnimation;
	
	this.getRefID							=	_getRefID;
	this.getName							=	_getName;
	this.getAliasName					=	_getAliasName;
	this.getHideInCourseMap		=	_getHideInCourseMap;	  
	this.getParentNavName			=	_getParentNavName;
	this.resetEntireCourse		=	_resetEntireCourse;		

	// new
	this.getParentIndex										=	_getParentIndex;
	this.getParentIndexForNavType					=	_getParentIndexForNavType;
	this.atBeginningOfSCO									=	_atBeginningOfSCO;
	this.atEndOfSCO												=	_atEndOfSCO;

	this.getChildrenID										=	_getChildrenID;
	this.getChildrenName									=	_getChildrenName;
	this.getChildrenIDTokens							=	_getChildrenIDTokens;
	this.getChildrenNameTokens						=	_getChildrenNameTokens;
	this.getTotalChildren									=	_getTotalChildren;
	this.getChildIDWithIndex							=	_getChildIDWithIndex;
	this.getChildNameWithIndex						=	_getChildNameWithIndex;
	// new -- till here

	// navigation.js
	this.getCurrentHistoryIndex						=	_getCurrentHistoryIndex;
	this.getPreviousHistoryEventID				=	_getPreviousHistoryEventID;
	this.getNextHistoryEventID						=	_getNextHistoryEventID;
	this.getFirstEvent										=	_getFirstEvent;
	this.gotoFirstEvent										=	_gotoFirstEvent;	
	this.gotoEvent												=	_gotoEvent;	
	this.gotoEventAndFrame								=	_gotoEventAndFrame;
	this.gotoEventWithBookmarkAnchor			=	_gotoEventWithBookmarkAnchor;
	this.gotoEventIfBookmark							=	_gotoEventIfBookmark;
	this.gotoHistoryNext									=	_gotoHistoryNext;
	this.gotoHistoryPrevious							=	_gotoHistoryPrevious;
	this.gotoChildNav											=	_gotoChildNav;
	this.gotoChildNavWithEventID					=	_gotoChildNavWithEventID;
	this.gotoChildNavAndFrameWithEventID	=	_gotoChildNavAndFrameWithEventID;
	this.buildBreadcrumb									=	_buildBreadcrumb;
	this.buildBreadcrumbNoURL							=	_buildBreadcrumbNoURL;	

	//status.js
	this.markItemCompletion								=	_markItemCompletion;
	this.markTreeItemCompletion						= _markTreeItemCompletion;
	this.checkSiblings										=	_checkSiblings;
	this.markNavLinkAndChildrenVisited		=	_markNavLinkAndChildrenVisited;
	this.markNodeAndChildrenVisited				=	_markNodeAndChildrenVisited;


	//highlevelapi -- course map
	this.XHTMLAppendChild										=	_XHTMLAppendChild;
	this.buildHierarchy											=	_buildHierarchy;
	this.buildHierarchyForFrameObject				=	_buildHierarchyForFrameObject;
	this.buildTopicHierarchyForFrameObject	=	_buildTopicHierarchyForFrameObject;
	this.buildHierarchyXHTMLData						=	_buildHierarchyXHTMLData;
	this.buildHierarchyXHTMLNode						=	_buildHierarchyXHTMLNode;
	this.expandBranchTraverse								=	_expandBranchTraverse;
	this.expandBranch												=	_expandBranch;
	this.swapCurrentEventImage							=	_swapCurrentEventImage;
	this.expandBranchForCurrentEvent				=	_expandBranchForCurrentEvent;
	this.setCourseHierarchyProperties				=	_setCourseHierarchyProperties;
	this.traverseLinksForHierarchy					=	_traverseLinksForHierarchy;
	this.createEmptyLeaf										=	_createEmptyLeaf;
	this.createTreeLeaf											=	_createTreeLeaf;
	this.createTreeFolder										=	_createTreeFolder;
	this.showBranch													=	_showBranch;
	this.swapFolder													=	_swapFolder;
	
	
	//-------------method definition-----------------//
	// initialize the navigation value
	function _initialize() {
		if(sNavID == null || sNavID == '') {
			sNavID = "1";
			return;
		}
		
		if(findNav(sNavID) == null) {
			if(new CUtil().isNumeric(sNavID) == false) {
				for(obj in m_arrNavs) {
					if(m_arrNavs[obj].NAME == sNavID) {
						sNavID = m_arrNavs[obj].ID;
						return;
					}
					if(m_arrNavs[obj].ALIASNAME == sNavID) {
						sNavID = m_arrNavs[obj].ID;
						return;
					}					
				}	
			}			
		}
	}			// initialise end
	
	function _getAnimation() {
		var objAnimate = new CAnimate();
		return objAnimate;
	}
	
	function _getRefID() {
		return this.id;
	}
	
	function _getName() {
		return this.name;
	}
	
	function _getAliasName() {
		return this.aliasName;
	}
	
	function _getHideInCourseMap() {
		return this.hideInCourseMap;
	}

	function _getParentNavName() {
		if(this.parent != null) {
			var objNavLink = findNavLink(1,this.parent.ID);	
		} else {
			var objNavLink = findNavLink(1,m_lAliasID);
		}
		
		var objNav = findNav(objNavLink.ORGID);
		if (objNav != null) {
			return objNav.ALIASNAME;
		} else {
			return "";
		}
	}
	
		
	function _resetEntireCourse() {
		for (var obj in m_arrEvents){
			var oEvent = new CEvent(obj,this.windowTarget);
			oEvent.resetEvent();
		}
	}	

	// new
	function _getParentIndex() {
		return this.getParentIndexForNavType(2, this.id);
	}
		
	function _getParentIndexForNavType(nType,lID) {
	  var oNavLink = findNavLink(nType,lID);
	
	  if (oNavLink != null) {
	    var oParentNavLink;
	  
	    if (nType == 1 ) {
	      oParentNavLink = findNavLink(2,oNavLink.ORGID);
	      if (oParentNavLink != null) {
	        return Number(oParentNavLink.SEQUENCE);
	      } else {
	        return 0;
	      }
	    } else if (nType == 2) {
	    	oParentNavLink = findNavLink(1,oNavLink.ORGID);
	      if (oParentNavLink != null) {
	        return Number(oParentNavLink.SEQUENCE);
	      } else {
	        return 0;
	      }
	    } else {
	      return 0;
	    }
	  } else {
	    return 0;
	  }		
	}

	function _atBeginningOfSCO() {
		var oEvent = new CEvent();
	  var nCurrentTopic = oEvent.getParentID();
	
	  if (oEvent.isFirstSibling() && nCurrentTopic == 1) {
	    return true;
	  } else {
	    return false;
	  }
	}
	
	function _atEndOfSCO() {
		var oEvent = new CEvent();
		var nNextEvent = oEvent.getNextEventID();
		var nChildren = oEvent.getTotalChildren();
		var nParentID = oEvent.getParentID();
		var oNext = new CSCOStructure(nParentID);
	  if (oEvent.isLastSibling() && nNextEvent == null && nChildren == 0 && oNext.next == null) {
	    return true;
	  } else {
	    return false;
	  }
	}


	function _getCurrentHistoryIndex() {
		return this.parentEngine.m_nHistoryCurIdx;
	}
         
	function _getPreviousHistoryEventID() {
		if (m_arrHistoryNav[m_nHistoryCurIdx-1] != null){
			return m_arrHistoryNav[m_nHistoryCurIdx-1];		
		}
		return null;	
	}
	
	function _getNextHistoryEventID() {
		if (m_arrHistoryNav[m_nHistoryCurIdx+1] != null){
			return m_arrHistoryNav[m_nHistoryCurIdx+1];		
		}		
		return null;
	}

	function _getFirstEvent() {
		//var oNavLink = findNavLinkWithOrgAndSeq(2,1,1);
		var oNavLink = findNavLinkWithOrgAndSeq(2,this.id,1);
		return oNavLink.DSTID;
	}

	function _getChildrenID() {
		var sResult = "";
		for(var i=0; i<this.children.length; i++) {
				sResult = sResult + "|" + this.children[i].ID;
		}
		sResult = sResult.substring(1);
		return sResult;
	}

	function _getChildrenName() {
		var sResult = "";
		for(var i=0; i<this.children.length; i++) {
				sResult = sResult + "|" + this.children[i].NAME;
		}
		sResult = sResult.substring(1);
		return sResult;
	}

	function _getChildrenIDTokens() {
		var sChildID = this.getChildrenID();
		var arrResult = sChildID.split("|");		
		return arrResult;
	}

	function _getChildrenNameTokens() {
		var sChildID = this.getChildrenName();
		var arrResult = sChildID.split("|");		
		return arrResult;
	}

	function _getTotalChildren() {
		return this.children.length;
	}

	function _getChildIDWithIndex(nIdx) {
		return this.getChildrenIDTokens()[nIdx-1];
	}

	function _getChildNameWithIndex(nIdx) {
		return this.getChildrenNameTokens()[nIdx-1];
	}

	function _gotoFirstEvent() {
		this.gotoEvent(this.getFirstEvent());
	}
	
	
	function _gotoEvent(sEventID) {
		var objEvent = new CEvent(sEventID,this.windowTarget);
		objEvent.saveHistory();
		// need to check by input scoid
		objEvent.loadEvent();
	}
	
	function _gotoEventAndFrame(sEventID,sFrameID) {
		var objEvent = new CEvent(sEventID,this.windowTarget);
		objEvent.saveHistory();
		lFrameID = objEvent.getFrame(sFrameID).getIndex();
		objEvent.loadEvent(lFrameID);
	}	


	function _gotoEventWithBookmarkAnchor(sEventID,sBMAnchor) {
		var objEvent = new CEvent(sEventID,this.windowTarget);
		objEvent.saveHistory(sEventID);
		objEvent.loadEvent(null,null,sBMAnchor);
	}	
	
	
	function _gotoEventIfBookmark() {
		if (m_bBookmarkHasParent) {
			m_bBookmarkHasParent = false;
			var oEvent = new CEvent(m_lBookmarkEventID,this.windowTarget);
			oEvent.gotoEvent();
		}
	}	
	

	function _gotoHistoryNext() {
		var nextEventID = m_arrHistoryNav[m_nHistoryCurIdx+1];
		if(nextEventID != null){
			m_nHistoryCurIdx++;  
			var objEvent = new CEvent(nextEventID,this.windowTarget);
			objEvent.loadEvent();
		}		
	}	
	
	
	function _gotoHistoryPrevious() {
		var prevEventID = m_arrHistoryNav[m_nHistoryCurIdx-1];
		if(prevEventID != null) {
			m_nHistoryCurIdx--;
			var objEvent = new CEvent(prevEventID,this.windowTarget);
			objEvent.loadEvent();			
		}		
	}	
		
			
	function _gotoChildNav() {
		this.gotoChildNavWithEventID(m_lEventID);
	}
	
	function _gotoChildNavWithEventID(lEventID,lFrameID) {
		var oNav;
		var oNavLink;
		var objEvent = new CEvent(lEventID,this.windowTarget);
		lEventID = objEvent.id;

		for (var i=0; i<m_arrNavLinks.length; i++) {
			if (m_arrNavLinks[i].ORGTYPE == 1 && m_arrNavLinks[i].ORGID == lEventID) {
				oNav = findNav(m_arrNavLinks[i].DSTID);
				if (oNav.NAME.toLowerCase() == this.name.toLowerCase()) {
					oNavLink = findNavLinkWithOrgAndSeq(2,oNav.ID,1);
					if (oNavLink != null) {
						if(lFrameID == null || lFrameID == '') {
							lFrameID = 1;
						}
						var objEvent = new CEvent(oNavLink.DSTID,this.windowTarget);
						lFrameID = objEvent.getFrame(lFrameID).getIndex();
						objEvent.saveHistory();
						objEvent.loadEvent(lFrameID);
					}
				}
			}
		}
	}
	
	function _gotoChildNavAndFrameWithEventID(lEventID,lFrameID) {
		this.gotoChildNavWithEventID(lEventID,lFrameID);
	}	
		
	
	function _buildBreadcrumb(lEventID,sURL) {
		var objNavLink = findNavLink(1,lEventID);
		var objParentNavLink = findNavLink(2,objNavLink.ORGID);
		var lParentID = parseInt(objParentNavLink.ORGID);
		var objEvent;
		if (lParentID > 1) {
			objEvent = findEvent(lParentID);
			sURL = "<a href='#' onclick='new CP.CSCOStructure().gotoEvent(" + lParentID  + "); return false;'>" + objEvent.NAME + "</a> &gt; " + sURL;
			return this.buildBreadcrumb(lParentID,sURL);
		}
		return sURL;
	}
	
	function _buildBreadcrumbNoURL(lEventID,sURL) {
		var objNavLink = findNavLink(1,lEventID);
		var objParentNavLink = findNavLink(2,objNavLink.ORGID);
		var lParentID = parseInt(objParentNavLink.ORGID);
		var objEvent;
		if (lParentID > 1) {
			objEvent = findEvent(lParentID);
			sURL = objEvent.NAME + " &gt; " + sURL;
			return this.buildBreadcrumbNoURL(lParentID,sURL);
		}
		return sURL;
	}
				
	
	//status.js
	function _markItemCompletion(oItem){
		var sStatus = "c";
		if (oItem.completionStatus != "c"){
			if (oItem.children.length > 0){
				for (var i=0;i<oItem.children.length;i++){
					if (oItem.children[i].completionStatus == "" || oItem.children[i].completionStatus == "n" || oItem.children[i].completionStatus == "i"){
						if (oItem.children[i].VISITED != "Ignore"){
							sStatus = "i";
							break;
						}	
					}	
				}
				if (oItem.arrFrames!=null){
					if (oItem.VISITED == "false" || oItem.VISITED == null){
						sStatus = "i";
					}	
				}
			}else{
				sStatus = "c";
	
			} 
			oItem.setCompletionStatus(sStatus);
	
		}
		this.markTreeItemCompletion(oItem,sStatus);
		if (oItem.parent != null){
			this.checkSiblings(oItem);	
		}	
	}		
	
	
	function _checkSiblings(oItem){
		var oParent = oItem.parent;
		var sStatus = "c";
		for (var i=0;i<oParent.children.length;i++){
			if (oParent.children[i].completionStatus == "" || oParent.children[i].completionStatus == "n" || oParent.children[i].completionStatus == "i"){
				if (oParent.children[i].VISITED != "Ignore"){	
					sStatus = "i";
					break;
				}	
			}	
		}
		if (oParent.arrFrames!=null){
			if (oParent.VISITED == "false" || oParent.VISITED == null){
				sStatus = "i";
			}	
		}	
		oParent.setCompletionStatus(sStatus);
		
		this.markTreeItemCompletion(oParent,sStatus);
		this.markItemCompletion(oParent);
	}
	
	function _markTreeItemCompletion(oItem,sStatus){
		if (this.parentEngine.m_bUsesCourseTree == "true"){
			for (var oTree in m_arrTrees){
				var oTreeNode;
				if (oItem.arrFrames!=null){
					oTreeNode = m_arrTreeItems[m_arrTrees[oTree].id + "_Event_" + oItem.ID];
				}else{
					oTreeNode = m_arrTreeItems[m_arrTrees[oTree].id + "_Nav_" + oItem.ID];						
				}	
				if (oTreeNode != null){
					oTreeNode.setCompletionStatus(sStatus);
				}
			}			
		}		
	}		
	
	
	function _markNavLinkAndChildrenVisited(sVisited) {
		this.markNodeAndChildrenVisited(2,this.id,sVisited);
	}
	
	
	function _markNodeAndChildrenVisited(nType,lID,sVisited) {
		var colOrgNodes;
		var colDstNodes;
		var nDstType;
		var lDstID;
	
		colOrgNodes = findNavLinks(nType,lID);
		//MarkEventVisited(lID,sVisited);
		for (var i=0; i<colOrgNodes.length; i++) {
			nDstType = colOrgNodes[i].DSTTYPE;
			lDstID = colOrgNodes[i].DSTID;
	
			colDstNodes = findNavLinks(nDstType,lDstID);
			if (colDstNodes.length == 0) {
				if (nDstType == 1) {
					var objEvent = new CEvent(lDstID,this.windowTarget);
					objEvent.markEventVisited(sVisited);
				}
			} else {
				if (nDstType == 1) {
					var objEvent = new CEvent(lDstID,this.windowTarget);
					objEvent.markEventVisited(sVisited);
				}
	
				this.markNodeAndChildrenVisited(nDstType,lDstID,sVisited);
			}
		}
	
	}	
	
	
	//--------highlevelapi.js----------//
	function _XHTMLAppendChild(oParentNode,oChildNode) {
		oParentNode.appendChild(oChildNode);
	}	
	
	function _buildHierarchy(bHideEvents) {
	
		if (bHideEvents == null){
			bHideEvents = false;
		}
			
		if (m_coursemap == null || m_coursemap.closed) {
			options = 'resizable=yes,scrollbars=yes,left='+(top.screen.width-320-50)+',top='+(top.screen.height-480)/2+',width='+320+',height='+480;
			oHTMLNode = new CXHTMLElement("html");
			oHEADNode = new CXHTMLElement("head");
			oTITLENode = new CXHTMLElement("title");
			oTITLENode.text = "Course Map";
			this.XHTMLAppendChild(oHEADNode,oTITLENode);
			oSCRIPTNode = new CXHTMLElement("script");
			//oSCRIPTNode.text = "var CP = opener.parent.engine;";
			oSCRIPTNode.text = "var CP = opener.parent.engine;";
			this.XHTMLAppendChild(oHEADNode,oSCRIPTNode);
			oSTYLENode = new CXHTMLElement("style");
			oSTYLENode.XHTMLCreateAttribute("type","text/css");
			sStyle = "";
			sStyle = sStyle + "body { font: 10pt Verdana,sans-serif; color:navy;}\ntable { font: 10pt Verdana,sans-serif; color:navy;}\n";
			oSTYLENode.text = sStyle;
			this.XHTMLAppendChild(oHEADNode,oSTYLENode);
			this.XHTMLAppendChild(oHTMLNode,oHEADNode);
				
			//create the script inline
			oSCRIPTNode = new CXHTMLElement("script");
			oSCRIPTNode.text = "CP = opener.parent.engine;";
			oSCRIPTNode.text = "targetwindow = window;";
			this.XHTMLAppendChild(oHTMLNode,oSCRIPTNode);							
				
			oBODYNode = new CXHTMLElement("body");
			oPNode = new CXHTMLElement("p");
			oPNode.text = this.sInstructions;
			this.XHTMLAppendChild(oBODYNode,oPNode);
			this.XHTMLAppendChild(oBODYNode,this.buildHierarchyXHTMLNode(bHideEvents));
			this.XHTMLAppendChild(oHTMLNode,oBODYNode);
			m_coursemap = open('','coursemap',options);
			m_coursemap.document.open();
			m_coursemap.document.write(oHTMLNode.xhtml());
			m_coursemap.document.close();
			this.parentEngine.m_coursemap = m_coursemap;
			oNavLinkNode = findNavLinks(2,1)[0];
			lDstID = oNavLinkNode.DSTID;
			this.showBranch("branch2;1;1;" + lDstID,m_coursemap);
			this.swapFolder("folder2;1;1;" + lDstID,m_coursemap);
		} else {
			m_coursemap.focus();			
		}	
	}		

	
	function _buildHierarchyForFrameObject(sFrameListObjectName) {
		var objFrmObject = new CFrameObject(sFrameListObjectName,this.windowTarget);
		objFrmObject.replaceWithExpression(this.buildHierarchyXHTMLData());
		oNavLinkNode = findNavLinks(2,1)[0];
	}
	
	function _buildTopicHierarchyForFrameObject(sFrameListObjectName) {
		var objFrmObject = new CFrameObject(sFrameListObjectName,this.windowTarget);
		objFrmObject.replaceWithExpression(this.buildHierarchyXHTMLData(true));
		oNavLinkNode = findNavLinks(2,1)[0];
	}
	
	function _buildHierarchyXHTMLData(bHideEvents) {
		if (bHideEvents == null){
			bHideEvents = false;
		}
		return this.buildHierarchyXHTMLNode(bHideEvents).xhtml();
	}	
	
	function _buildHierarchyXHTMLNode(bHideEvents) {
		oNode = new CXHTMLElement("span");
		this.traverseLinksForHierarchy(2,1,oNode,bHideEvents);
		return oNode;
	}
	
	
	function _expandBranchTraverse(nType,lID) {	
		if (nType==2 && lID==1){
			return;
		}
	
		var oNavLink = findNavLink(nType,lID);
		var nOrgType = oNavLink.ORGTYPE;
		var lOrgID = oNavLink.ORGID;
		var nDstType = oNavLink.DSTTYPE;
		var lDstID = oNavLink.DSTID;
		arrPush(m_arrBranch,"branch" + nOrgType + ";" + lOrgID + ";" + nDstType + ";" + lDstID);
		this.expandBranchTraverse(nOrgType,lOrgID);
	}
	
	
	function _expandBranch(targetwindow) {
		if (targetwindow==null){
			targetwindow = parent.content;
		}
		
		m_arrBranch = new Array();
	
		var oNavLink = findNavLink(1,m_lEventID);
		var nOrgType = oNavLink.ORGTYPE;
		var lOrgID = oNavLink.ORGID;
		
		this.expandBranchTraverse(nOrgType,lOrgID);
		
		for (i=m_arrBranch.length-1;i>=0;i--){
			this.showBranch(m_arrBranch[i],targetwindow)
		}
	}
	
	function _swapCurrentEventImage(sImg,targetwindow) {
		var ImageSwap = new Object();
		
		if (targetwindow==null){
			targetwindow = parent.content;
		}		
		if (targetwindow.document.getElementById("img_tree_event_" + m_lEventID) == null){
			var oNavLink = findNavLink(1,m_lEventID);
			if (targetwindow.document.getElementById("img_tree_nav_" + oNavLink.ORGID) != null){	
				ImageSwap.window = targetwindow;
				ImageSwap.name = "img_tree_nav_" + oNavLink.ORGID;
				ImageSwap.src=targetwindow.document.getElementById("img_tree_nav_" + oNavLink.ORGID).src;
				targetwindow.document.getElementById("img_tree_nav_" + oNavLink.ORGID).src=m_sContentDir + "/" +sImg;		
			}	
		}else{	
			ImageSwap.window = targetwindow;
			ImageSwap.name = "img_tree_event_" + m_lEventID;
			ImageSwap.src=targetwindow.document.getElementById("img_tree_event_" + m_lEventID).src;
			targetwindow.document.getElementById("img_tree_event_" + m_lEventID).src=m_sContentDir + "/" +sImg;
			
		}	
		arrPush(aSwapImages,ImageSwap);
	}
	
	function _expandBranchForCurrentEvent(targetwindow) {
		this.expandBranch(targetwindow);
	}
	
	function _setCourseHierarchyProperties(sOpenFolder, sClosedFolder, sEventIcon, nIndentSpacing, nVerticalSpacing, sInstructions) {
		if (sOpenFolder != null){
			this.sOpenFolder =  sOpenFolder;				
		}	
		if (sClosedFolder != null){
			this.sClosedFolder =  sClosedFolder;				
		}	
		if (sEventIcon != null){
			this.sEventIcon =  sEventIcon;				
		}
		if (sInstructions != null){
			this.sInstructions =  sInstructions;				
		}
		if (nIndentSpacing != null){	
			this.nIndentSpacing = "margin-left: " + nIndentSpacing + ";";
		}
		if (nVerticalSpacing != null){
			this.nVerticalSpacing	= "height: " + nVerticalSpacing + ";";
	    }		
	}	

	function _traverseLinksForHierarchy(nOriginType, lOriginID, oNewNode, bHideEvents) {
		var colOrgNodes;
		var colDstNodes;
		var nDstType;
		var lDstID;
		var objEvent;
		var oSPANNode;
		colOrgNodes = findNavLinks(nOriginType,lOriginID);
		for (var i=0; i<colOrgNodes.length; i++) {
			var nOrgType = colOrgNodes[i].ORGTYPE;
			var lOrgID = colOrgNodes[i].ORGID;
			nDstType = colOrgNodes[i].DSTTYPE;
			lDstID = colOrgNodes[i].DSTID;
			var lSeq = colOrgNodes[i].SEQUENCE;
			var sKey = nOrgType + ";" + lOrgID + ";" + nDstType + ";" + lDstID;
			colDstNodes = findNavLinks(nDstType,lDstID);
			if (colDstNodes.length == 0  && bHideEvents == false) {
				if (nDstType==1){
					objEvent = findEvent(lDstID);
					if (convertNull(m_arrEvents[lDstID])!=""){
						if (convertNull(m_arrEvents[lDstID].HIDEINCOURSEMAP) != "True"){
							this.createTreeLeaf(oNewNode,objEvent,sKey,lDstID);
						}else{
							this.createEmptyLeaf(oNewNode);
						}	
					}				
				}else if (nDstType == 2) {
		        oNavNode = findNav(lDstID);
		        if (convertNull(m_arrNavs[lDstID])!=""){
			        if (convertNull(m_arrNavs[lDstID].HIDEINCOURSEMAP) != "True"){
							this.createTreeLeaf(oNewNode,oNavNode,sKey,"");
						}else{
							this.createEmptyLeaf(oNewNode);
						}
					}					
				}
								
			} else if(colDstNodes.length > 0){
				
				if (nDstType == 1) {
		            objEvent = findEvent(lDstID);
		            if (convertNull(m_arrEvents[lDstID])!=""){
			            if (convertNull(m_arrEvents[lDstID].HIDEINCOURSEMAP) != "True"){
											oSPANNode = this.createTreeFolder(oNewNode,objEvent,sKey,lDstID,1);
											this.traverseLinksForHierarchy(nDstType, lDstID, oSPANNode, bHideEvents);
									}else{
											this.createEmptyLeaf(oNewNode);
									}
								}						
				} else if (nDstType == 2) {
		            oNavNode = findNav(lDstID);
		            if (convertNull(m_arrNavs[lDstID])!=""){
			            if (convertNull(m_arrNavs[lDstID].HIDEINCOURSEMAP) != "True") {
										if (bHideEvents == false){
												oSPANNode = this.createTreeFolder(oNewNode,oNavNode,sKey,lDstID,2);
												this.traverseLinksForHierarchy(nDstType, lDstID, oSPANNode,bHideEvents);
										} else {
												arrLinks = findNavLinks(2,lDstID);
												var bMakeFolder = false;
												for (var k=0;k<arrLinks.length;k++){
													if (findNavLinks(1,arrLinks[k].DSTID).length > 0){
														bMakeFolder = true;
													}		
												}	
								
								templDstID = findNavLinkWithOrgAndSeq(nDstType,lDstID,1).DSTID;
								if (bMakeFolder == false){
									this.createTreeLeaf(oNewNode,oNavNode,sKey,templDstID,2);
								}else{
									if (findNavLinks(1,templDstID) != null){
										oSPANNode = this.createTreeFolder(oNewNode,oNavNode,sKey,templDstID,1);
									}else{	
										oSPANNode = this.createTreeFolder(oNewNode,oNavNode,sKey,lDstID,1);
									}
									this.traverseLinksForHierarchy(nDstType, lDstID, oSPANNode,bHideEvents);
								}	
							}
						}else{
							this.createEmptyLeaf(oNewNode);
						}
					}					
				}
			}
		}
	}

	function _createEmptyLeaf(oNewNode) {
		var oSPANNode;
		oSPANNode = new CXHTMLElement("DIV");
		this.XHTMLAppendChild(oNewNode,oSPANNode);
	}


	function _createTreeLeaf(oNewNode,oNode,sKey,lDstID,lType) {
		var oSPANNode;
		var oDIVNode;
		var oIMGNode;
		var oANode;
		var oBRNode;
		var oTable;
		var oTR;
		var oTD;
		
		oSPANNode = new CXHTMLElement("DIV");
		oSPANNode.XHTMLCreateAttribute("style",this.nVerticalSpacing);
		oTable = new CXHTMLElement("table");
		oTR = new CXHTMLElement("tr");
		oTD = new CXHTMLElement("td");
		oIMGNode = new CXHTMLElement("img");
		if (lType == 2){
			oIMGNode.XHTMLCreateAttribute("id","img_tree_nav_"+findNavLink(1,lDstID).ORGID);
		}else{	
			oIMGNode.XHTMLCreateAttribute("id","img_tree_event_"+lDstID);
		}			
		oIMGNode.XHTMLCreateAttribute("src",m_sContentDir + "/" + this.sEventIcon);
		oIMGNode.XHTMLCreateAttribute("border","0");
		oIMGNode.XHTMLCreateAttribute("onClick","CP.objSCOst.gotoEvent(" + lDstID + ");return false;");
		this.XHTMLAppendChild(oTD,oIMGNode);
		this.XHTMLAppendChild(oTR,oTD);
		oTD = new CXHTMLElement("td");
		oANode = new CXHTMLElement("a");
		oANode.XHTMLCreateAttribute("href","#");
		oANode.XHTMLCreateAttribute("onClick","CP.objSCOst.gotoEvent(" + lDstID + ");return false;");
		if (lType==2){
			oANode.text = oNode.ALIASNAME;
		}else{
			if (oNode.ALIASNAME != null){
				oANode.text = oNode.ALIASNAME;
			}else{	
				oANode.text = oNode.NAME;
			}	
		}		
		this.XHTMLAppendChild(oTD,oANode);					
		this.XHTMLAppendChild(oTR,oTD);
		this.XHTMLAppendChild(oTable,oTR);
		this.XHTMLAppendChild(oSPANNode,oTable);					
		this.XHTMLAppendChild(oNewNode,oSPANNode);
	}

	function _createTreeFolder(oNewNode,oNode,sKey,lDstID,nType) {
		var oSPANNode;
		var oIMGNode;
		var oANode;
		var oBRNode;
		var oTable;
		var oTR;
		var oTD;
		
		oSPANNode = new CXHTMLElement("DIV");
		oSPANNode.XHTMLCreateAttribute("style","cursor: pointer; cursor: hand; " + this.nVerticalSpacing);
		oTable = new CXHTMLElement("table");
		oTR = new CXHTMLElement("tr");
		oTD = new CXHTMLElement("td");
		oIMGNode = new CXHTMLElement("img");
		oIMGNode.XHTMLCreateAttribute("src",m_sContentDir + "/" + this.sClosedFolder);
		oIMGNode.XHTMLCreateAttribute("border","0");
		oIMGNode.XHTMLCreateAttribute("id","folder" + sKey);
		oIMGNode.XHTMLCreateAttribute("onclick","CP.objSCOst.showBranch('branch" + sKey + "',window);CP.objSCOst.swapFolder('folder" + sKey + "',window);return false;");
		this.XHTMLAppendChild(oTD,oIMGNode);
		this.XHTMLAppendChild(oTR,oTD);
		oTD = new CXHTMLElement("td");
		if (nType == 1) {
			oANode = new CXHTMLElement("a");
			oANode.XHTMLCreateAttribute("href","#");
			oANode.XHTMLCreateAttribute("onClick","CP.objSCOst.gotoEvent(" + lDstID + ");return false;");
			if (oNode.ALIASNAME != null){
				oANode.text = oNode.ALIASNAME;
			}else{
				oANode.text = oNode.NAME;
			}	
			this.XHTMLAppendChild(oTD,oANode);
			this.XHTMLAppendChild(oTR,oTD);
		} else {
			templDstID = findNavLinkWithOrgAndSeq(nType,lDstID,1).DSTID;	
			oANode = new CXHTMLElement("a");
			oANode.XHTMLCreateAttribute("href","#");
			oANode.XHTMLCreateAttribute("onClick","CP.objSCOst.gotoEvent(" + templDstID + ");return false;");
			if (oNode.ALIASNAME != null){
				oANode.text = oNode.ALIASNAME;
			}else{
				oANode.text = oNode.NAME;
			}	
			this.XHTMLAppendChild(oTD,oANode);
			this.XHTMLAppendChild(oTR,oTD);
		}

		this.XHTMLAppendChild(oTable,oTR);
		this.XHTMLAppendChild(oSPANNode,oTable);
		this.XHTMLAppendChild(oNewNode,oSPANNode);
		oSPANNode = new CXHTMLElement("span");
		oSPANNode.XHTMLCreateAttribute("style","display: none; " + this.nIndentSpacing);
		oSPANNode.XHTMLCreateAttribute("id","branch" + sKey);
		this.XHTMLAppendChild(oNewNode,oSPANNode);

		return oSPANNode;
	}


	function _showBranch(branch,targetwindow){
		if (branch == ""){return}
		if (targetwindow == null){
			targetwindow = parent.content;
		}
		
		if (targetwindow.document.getElementById(branch) != null){
			var objBranch = targetwindow.document.getElementById(branch).style;
		
			if(objBranch.display=="block")
				objBranch.display="none";
			else
				objBranch.display="block";
		}		
	}

	function _swapFolder(img,targetwindow) {
		if (targetwindow == null){
			targetwindow = parent.content;
		}
		if (targetwindow.document.getElementById(img) != null){
			objImg = targetwindow.document.getElementById(img);
			if(objImg.src.indexOf(this.sClosedFolder)>-1)
				objImg.src = m_sContentDir + "/" + this.sOpenFolder;
			else
				objImg.src = m_sContentDir + "/" + this.sClosedFolder;
		}				
	}

		
	//--------------------------------------------------------//
	
}			// class