﻿function CSimpro(sSimObject,targetwindow) {
	//-------------property declaration-----------------//
	initialize();
	
	this.simproObject									=	sSimObject;
	this.windowtarget									=	this.window;
	
	if(targetwindow == null) {
		this.windowTarget								=	parent.content;
	} else {
		this.windowTarget								=	targetwindow;
	}	
	

	//------------class inheritance and frame object validation----------//
	var objUtil												=	new CUtil();
	var objFrameObject	 							=	new CFrameObject(this.simproObject,this.windowTarget);
	this.isFrameObjectExists					=	objFrameObject.isFrameObjectExists();
	
	if(this.windowTarget.arrContent[this.simproObject] != null) {
		this.filename											=	this.windowTarget.arrContent[this.simproObject].FILENAME;
		this.mode													=	this.windowTarget.arrContent[this.simproObject].MODE;
		this.spNewWin											=	this.windowTarget.arrContent[this.simproObject].SPNEWWIN;
		this.spNewWinWidth								=	this.windowTarget.arrContent[this.simproObject].SPNEWWINWIDTH;
		this.spNewWinHeight								=	this.windowTarget.arrContent[this.simproObject].SPNEWWINHEIGHT;
		this.spNewWinCenter								=	this.windowTarget.arrContent[this.simproObject].SPNEWWINCENTER;
		this.spNewWinLeft									=	this.windowTarget.arrContent[this.simproObject].SPNEWWINLEFT;
		this.spNewWinTop									=	this.windowTarget.arrContent[this.simproObject].SPNEWWINTOP;
		this.extension										=	this.windowTarget.arrContent[this.simproObject].EXTENSION;
		this.minScore											=	this.windowTarget.arrContent[this.simproObject].MINSCORE;
		this.multiInteractions						=	this.windowTarget.arrContent[this.simproObject].MULTIINTERACTIONS;
		this.scrollbars										=	this.windowTarget.arrContent[this.simproObject].SCROLLBARS;
	}

	//-------------method declaration-----------------//
	this.getSimproFilename						=	_getSimproFilename;
	this.getSimproMode								=	_getSimproMode;
	this.getSimproNewWindow						=	_getSimproNewWindow;
	this.getSimproNewWinWidth					=	_getSimproNewWinWidth;
	this.getSimproNewWinHeight				=	_getSimproNewWinHeight;
	this.getSimproNewWinCenter				=	_getSimproNewWinCenter;
	this.getSimproNewWinLeft					=	_getSimproNewWinLeft;
	this.getSimproNewWinTop						=	_getSimproNewWinTop;
	this.getSimproExtension						=	_getSimproExtension;
	this.getSimproMinScore						=	_getSimproMinScore;
	this.getSimproMultiInteractions		=	_getSimproMultiInteractions;
	this.getSimproScrollbars					=	_getSimproScrollbars;


	//------------methods from inherited class----------//
	this.getVisibility							=	function() 									{return objFrameObject.getVisibility() };
	this.setVisibility							=	function(sState) 						{objFrameObject.setVisibility(sState) };
	this.getObjectZIndex						=	function() 									{return objFrameObject.getObjectZIndex() };
	this.setObjectZIndex						=	function(nZIndex) 					{objFrameObject.setObjectZIndex(nZIndex) };	
	this.moveObject									=	function(x,y) 							{return objFrameObject.moveObject(x,y) };
	this.resizeFrameObject					=	function(x,y,width,height)	{return objFrameObject.resizeFrameObject(x,y,width,height) };
	this.getLayerNameForObject			=	function() 									{return objFrameObject.getLayerNameForObject() };
	this.getPositionAndSize					= function()									{return objFrameObject.getPositionAndSize() };

	//-------------method definition-----------------//	
	function initialize() {
		if(sSimObject == '[object]') {
			sSimObject =	new CFrameObject(sSimObject).getCurrentFrameObjectName();
		}
	}	
	
	function _getSimproFilename() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.filename;
	}
	
	function _getSimproMode() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.mode;
	}
	
	function _getSimproNewWindow() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.spNewWin;
	}
	
	function _getSimproNewWinWidth() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.spNewWinWidth;
	}
	
	function _getSimproNewWinHeight() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.spNewWinHeight;
	}
	
	function _getSimproNewWinCenter() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.spNewWinCenter;
	}
	
	function _getSimproNewWinLeft() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.spNewWinLeft;
	}
	
	function _getSimproNewWinTop() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.spNewWinTop;
	}
	
	function _getSimproExtension() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.extension;
	}
	
	function _getSimproMinScore() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.minScore;
	}
	
	function _getSimproMultiInteractions() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.multiInteractions;
	}
	
	function _getSimproScrollbars() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.simproObject);
		}		
		
		return this.scrollbars;	
	}

	//----------------------------------------------------//	
	
}			// class


function spdonescore(complete) {
	new CQuestion().spDoneScore(complete);
}

function spdonenoscore(bNewWin) {
	new CQuestion().spDoneNoScore(bNewWin);
}