
function subCodeMatch(buttonSubCodes, selectedItem)
{
   if (buttonSubCodes == '')
      return false;

    var subCodeItems = buttonSubCodes.split('+');
    for(var i = 0; i < subCodeItems.length; i++)
   {
      if (subCodeItems[i] == selectedItem)
         return true;
   }
   return false;
}

function drawSide(sideButtons, selectedItem, button_title )
{
    var selectedTitle;
    // Draw side WLS buttons, according to array provided
    // Generates rows for an existing table

    // 03/03/2004 A.T. - Just to have a default value for selectedTitle
    selectedTitle = button_title;

    // Draw side WLS buttons, according to array provided
    // Generates rows for an existing table
    if (sideButtons != null){
        var menuResult='';
          var prevType = "";
          var menuItem = "";
        var openSecondLevel = 0;

        for ( var i = 0; i < sideButtons.length; i++ )
        {
            var sideButtonItems = sideButtons[i].split('|');
            var buttonCode = sideButtonItems[0];
            var buttonType = sideButtonItems[1];
            var buttonText = sideButtonItems[2];
            var buttonHref = sideButtonItems[3];
            var buttonSubCodes = '';
            if (sideButtonItems.length > 4)
                buttonSubCodes = sideButtonItems[4];

                // first level buttons have "lt_" prefix
                // second level buttons are usual "navigation", "function", "information", ... types
                //        (without "lt_" prefix)
                // subcodes will appear as third (maximum for now) level
            if ( ( prevType.substring( 0, 3 ) == 'lt_' || prevType.substring( 0, 3 ) == 'LT_' )
                     && ( buttonType.substring( 0, 3 ) != 'lt_' ) && ( buttonType.substring( 0, 3 ) != 'LT_' ) )
            {
                openSecondLevel = 1;
                   menuResult += '<div class="second-level">';
            }

            // close a possible second level opened before
            if ( ( buttonType.substring( 0, 3 ) == 'lt_' || buttonType.substring( 0, 3 ) == 'LT_' )
                     && ( prevType.substring( 0, 3 ) != 'lt_' ) && ( prevType.substring( 0, 3 ) != 'LT_' )
                     && openSecondLevel == 1 )
            {
                   openSecondLevel = 0;
                   menuResult += '</div>';
            }

            if ((selectedItem == buttonCode) || ((selectedItem == 'toc1') && (buttonCode == 'workspace')))
            {
                menuItem = '<a class="active" href="'+buttonHref+'">'+buttonText+'&nbsp;</a>\n';
                menuResult += menuItem;

                selectedTitle = buttonText;
               }
            else if ( subCodeMatch(buttonSubCodes, selectedItem) )
            {
                   // only one possible entry (corresponding to a subcode) for now in a third level left menu

                // parent
                menuItem = '<a href="'+ buttonHref + '">' + buttonText + '&nbsp;</a>\n' ;
                menuResult += menuItem;
                // child
                   menuResult += '<div class="third-level">';
                // todo: get from where full curent URL... meanwhile just reload page
                // menuItem = '<a class="active" href="'+buttonHref+'">'+button_title+'&nbsp;</a>\n';
                menuItem = '<a class="active" href="javascript:location.reload()">'+button_title+'&nbsp;</a>\n';

                menuResult += menuItem;
                menuResult += '</div>';

                   selectedTitle = buttonText;
               }
               else
               {
                menuItem = '<a href="'+ buttonHref + '">' + buttonText + '&nbsp;</a>\n';
                menuResult += menuItem;
            }

            prevType = buttonType;
        }
    }
    document.write(menuResult);

    return selectedTitle;
}


function drawSideTOC( sideButtons, selectedItem, button_title,
                      toc_action, toc_url, toc_title, current_language)
{
    var selectedTitle;
    // Draw side WLS buttons, according to array provided
    // Generates rows for an existing table

    // 03/03/2004 A.T. - Just to have a default value for selectedTitle
    selectedTitle = button_title;

    // Draw side WLS buttons, according to array provided
    // Generates rows for an existing table
    if (sideButtons != null){
        var menuResult='';
          var prevType = "";
          var menuItem = "";
        var openSecondLevel = 0;

        for ( var i = 0; i < sideButtons.length; i++ )
        {
            var sideButtonItems = sideButtons[i].split('|');
            var buttonCode = sideButtonItems[0];
            var buttonType = sideButtonItems[1];
            var buttonText = sideButtonItems[2];
            var buttonHref = sideButtonItems[3];
            if ( current_language != '' )
            {
                buttonHref = buttonHref + '&language=' + current_language;
            }
            var buttonSubCodes = '';
            if (sideButtonItems.length > 4)
                buttonSubCodes = sideButtonItems[4];

            // first level buttons have "lt_" prefix
            // second level buttons are usual "navigation", "function", "information", ... types
            //        (without "lt_" prefix)
            // subcodes will appear as third (maximum for now) level
            if ( ( prevType.substring( 0, 3 ) == 'lt_' || prevType.substring( 0, 3 ) == 'LT_' )
                     && ( buttonType.substring( 0, 3 ) != 'lt_' ) && ( buttonType.substring( 0, 3 ) != 'LT_' ) )
            {
                openSecondLevel = 1;
                   menuResult += '<div class="second-level">';
            }

            // close a possible second level opened before
            if ( ( buttonType.substring( 0, 3 ) == 'lt_' || buttonType.substring( 0, 3 ) == 'LT_' )
                     && ( prevType.substring( 0, 3 ) != 'lt_' ) && ( prevType.substring( 0, 3 ) != 'LT_' )
                     && openSecondLevel == 1 )
            {
                   openSecondLevel = 0;
                   menuResult += '</div>';
            }

            if (selectedItem == buttonCode)
            {
                menuItem = '<a class="active" href="'+buttonHref+'">'+buttonText+'&nbsp;</a>\n';
                menuResult += menuItem;

                selectedTitle = buttonText;
               }
            else if ((buttonCode == 'workspace') && (toc_action != '') && (toc_title != ''))
            {
                // SE 04/04/2005 If move between offerings with toc_curricula e.g. STG to SMS
                // the toc_action can be retained but the toc_title should not be set, so can detect
                menuItem = '<a href="'+buttonHref+'">'+buttonText+'&nbsp;</a>\n';
                menuResult += menuItem;
                   menuResult += '</div>';
                   menuResult += '<div class="second-level">';

                if (subCodeMatch(buttonSubCodes, selectedItem))
                {
                    if ((selectedItem == 'toc') || (selectedItem == 'sms_roadmap'))
                    {
                        menuItem = '<a class="active" href="javascript:location.reload()">' + toc_title + '&nbsp;</a>\n' ;
                        menuResult += menuItem;
                           selectedTitle = buttonText;
                    }
                    else
                    {
                        menuItem = '<a href="'+toc_url+'">'+toc_title+'&nbsp;</a>\n';
                        menuResult += menuItem;
                           selectedTitle = toc_title;
                    }
                       // document.write('<tr><td width="5" valign="top" class="hil"><img src="//www.ibm.com/i/c.gif" width="5" height="1" alt="" />&#183;</td><td width="145" class="hil">' + button_title + '</td></tr>');

                    // parent
                    // menuItem = '<a href="'+ buttonHref + '">' + buttonText + '&nbsp;</a>\n' ;
                    // menuResult += menuItem;

                    // child
                       menuResult += '<div class="third-level">';
                    // todo: get from where full curent URL... meanwhile just reload page
                    // menuItem = '<a class="active" href="'+buttonHref+'">'+button_title+'&nbsp;</a>\n';
                    menuItem = '<a class="active" href="javascript:location.reload()">'+button_title+'&nbsp;</a>\n';
                    menuResult += menuItem;
                    menuResult += '</div>';

                       selectedTitle = buttonText;
                }
                else
                {
                    if ((selectedItem == 'toc') || (selectedItem == 'sms_roadmap'))
                    {
                        menuItem = '<a class="active" href="javascript:location.reload()">' + toc_title + '&nbsp;</a>\n' ;
                        menuResult += menuItem;
                           selectedTitle = buttonText;
                    }
                    else
                    {
                        menuItem = '<a href="'+toc_url+'">'+toc_title+'&nbsp;</a>\n';
                        menuResult += menuItem;
                           selectedTitle = toc_title;
                    }
                }

            }
            else if ( subCodeMatch(buttonSubCodes, selectedItem) )
            {
                   // only one possible entry (corresponding to a subcode) for now in a third level left menu

                // parent
                menuItem = '<a href="'+ buttonHref + '">' + buttonText + '&nbsp;</a>\n' ;
                menuResult += menuItem;
                // child
                   menuResult += '<div class="third-level">';
                // todo: get from where full curent URL... meanwhile just reload page
                // menuItem = '<a class="active" href="'+buttonHref+'">'+button_title+'&nbsp;</a>\n';
                menuItem = '<a class="active" href="javascript:location.reload()">'+button_title+'&nbsp;</a>\n';

                menuResult += menuItem;
                menuResult += '</div>';

                   selectedTitle = buttonText;
               }
               else
               {
                menuItem = '<a href="'+ buttonHref + '">' + buttonText + '&nbsp;</a>\n';
                menuResult += menuItem;
            }

            prevType = buttonType;
        }
    }
    document.write(menuResult);

    return selectedTitle;
}



function drawSideTOC_old_style( sideButtons, selectedItem, bAll,
                      button_title, toc_action, toc_url, toc_title, current_language)
{
    // Draw side WLS buttons, according to array provided
    // Generates rows for an existing table

    document.write('<STYLE>');
    document.write('.mbg { background-color : #6666FF; }');
    document.write('.lbg { background-color : #FFFFFF; }');
    document.write('.hil { background-color : #ffffff; }');
    document.write('</STYLE>');

    if (sideButtons == null)
    {
        document.write('<tr><td colspan="2" background="./ibmintra/images/separator_line.gif"><img height="1" src="./ibmintra/images/odot.gif" width="1" /></td><td align="right" bgcolor="#6666ff"><img src="./ibmintra/images/separator_bottom.gif" /
r>');
        return button_title;
    }

    var bar=0;
    var prevType = "";
    for ( var i = 0; i < sideButtons.length; i++ )
    {
        var sideButtonItems = sideButtons[i].split('|');
        var buttonCode = sideButtonItems[0];
        var buttonType = sideButtonItems[1];
        var buttonText = sideButtonItems[2];
        var buttonHref = sideButtonItems[3];
        if ( current_language != '' )
        {
            buttonHref = buttonHref + '&language=' + current_language;
        }

        var buttonSubCodes = '';
        if (sideButtonItems.length > 4)
            buttonSubCodes = sideButtonItems[4];

        if ((bAll != false) || (buttonType == 'side'))
        {
            if ( (bAll != false) && (i > 0) && (buttonType != prevType))
            {
               // put separator to split into functional groups
                   document.write('<tr><td colspan="2" background="./ibmintra/images/separator_line.gif"><img height="1" src="./ibmintra/images/odot.gif" width="1" /></td><td align="right" bgcolor="#6666ff"><img src="./ibmintra/images/separator_bo
 /></td></tr>');
                   document.write('<tr><td colspan="3" bgcolor="#ffffff"><img height="2" src="./ibmintra/images/odot.gif" width="1" /></td></tr>');
                   document.write('<tr><td colspan="2" bgcolor="#6666ff"><img height="1" src="./ibmintra/images/odot.gif" width="1" /></td><td><img src="./ibmintra/images/separator_top.gif"></td></tr>');
                   bar = 1;    // prevent bar separator
            }

            if (selectedItem == buttonCode)
            {
                if ( i == 0 )
                {
                    document.write('<tr><td colspan="3" bgcolor="#6666FF"><img src="./ibmintra/images/odot.gif" height="1" /></td></tr>');
                }
                   document.write('<tr><td width="8" height="21" bgcolor="#FFFFFF">&nbsp;</td><td class="nav">' + buttonText + '</td></tr>');
                   bar = 1;
               }
            else if ((buttonCode == 'workspace') && (toc_action != ''))
            {
                var workspace_class = "nav"; // todo: find correct classes to use
                if ((selectedItem == 'toc') || subCodeMatch(buttonSubCodes, selectedItem))
                    workspace_class = "nav2";

                   // document.write('<tr><td colspan="2" class="' + workspace_class + '" align="left"><a href="'+ buttonHref +'" class="nav2" target="_top">' + buttonText + '</a></td></tr>');
                document.write('<tr><td width="8" height="21" bgcolor="#6666FF">&nbsp;</td><td bgcolor="#6666FF"><span class="' + workspace_class + '"><a href="'+ buttonHref +'" target="_top">' + buttonText + '</a></span></td><td width="8" height=
lor="#6666FF">&nbsp;</td></tr>');

                if (selectedItem == 'toc')
                {
                    // document.write('<tr><td width="5" valign="top" class="hil"><img src="//www.ibm.com/i/c.gif" width="5" height="1" alt="" />&#183;</td>');
                    // document.write('<td width="145" class="hil">' + toc_title + '</td></tr>');

                       document.write('<tr><td width="8" height="21" bgcolor="#FFFFFF">&nbsp;</td><td class="nav">' + toc_title + '</td></tr>');
                }
                else
                {
                       // document.write('<tr><td width="5" valign="top" class="' + workspace_class + '"><img src="//www.ibm.com/i/c.gif" width="5" height="1" alt="" />&#183;</td>');
                    // document.write('<td width="145" class="' + workspace_class + '"><a href="'+ toc_url +'" class="nav2" target="_top">' + toc_title + '</a></td></tr>');

                    document.write('<tr><td width="8" height="21" bgcolor="#6666FF">&nbsp;</td><td bgcolor="#6666FF"><span class="' + workspace_class + '"><a href="'+ toc_url +'" target="_top">' + toc_title + '</a></span></td><td width="8" height=
lor="#6666FF">&nbsp;</td></tr>');
                }
            }
            else
            {
                if ( (bar == 0 ) && ( i > 0 ) )
                {
                    document.write('<tr><td bgcolor="#6666FF"><img height="1" src="./ibmintra/images/odot.gif" width="1" /></TD>');
                    document.write('<td bgColor=#FFFFFF ><img height="1" src="./ibmintra/images/odot.gif" width="130" /></TD>');
                    document.write('<td bgcolor="#6666FF"><img height="1" src="./ibmintra/images/odot.gif" width="1" /></TD></TR>');
                   }
                  else
                  {
                    bar = 0;
                  }
                document.write('<tr><td width="8" height="21" bgcolor="#6666FF">&nbsp;</td><td bgcolor="#6666FF"><span class="nav"><a href="'+ buttonHref +'" target="_top">' + buttonText + '</a></span></td><td width="8" height="21" bgcolor="#6666F
</td></tr>');
            }
        }
        prevType = buttonType;
    }

    document.write('<tr><td colspan="2" background="./ibmintra/images/separator_line.gif"><img height="1" src="./ibmintra/images/odot.gif" width="1" /></td><td align="right" bgcolor="#6666ff"><img src="./ibmintra/images/separator_bottom.gif" /></t
;
}

function displayDate(firstname, lastname)
{
   var months=new Array(13);
   months[1]="January";
   months[2]="February";
   months[3]="March";
   months[4]="April";
   months[5]="May";
   months[6]="June";
   months[7]="July";
   months[8]="August";
   months[9]="September";
   months[10]="October";
   months[11]="November";
   months[12]="December";
   var time=new Date();
   var lmonth=months[time.getMonth() + 1];
   var date=time.getDate();
   var year=time.getYear();
   if (year < 2000)
   year = year + 1900;
   document.write(date + " ");
   document.write(lmonth + " " + year);
   if ((firstname != null) && (lastname != null))
   {
       // firstname, lastname may contain '
       document.write(',Hello ');    //ONLY SHOW THIS LINE WHEN SIGNED ON
       document.write(firstname);
       document.write(' ');
       document.write(lastname);
       document.write('');

   }
}


function doNothing()
{
}

function getPageTitle(id, title, long_title)
{
   return title;
}

function insertElementInButtons( aOriginal, strCodeToSearch, eNewElement )
{
    var aResult='';
      var prevType = "";
      var menuItem = "";
    var openSecondLevel = 0;

    for ( var i = 0; i < aOriginal.length; i++ )
    {
        var sideButtonItems = sideButtons[i].split('|');
        var buttonCode = sideButtonItems[0];
        if ( buttonCode == strCodeToSearch )
        {
            // move all elements down 1 unit
            // to do ....
            break;
        }
    }

    return aResult;
}