﻿var IS_IE;
var IS_MOZ = (document.implementation && document.implementation.createDocument)?true:false;
if (!IS_MOZ) {
    IS_IE = (navigator.userAgent.toLowerCase().indexOf("msie") > -1)?true:false;
} else {
    IS_IE = false;
}


var m_bPostSuccess;
var m_nCommentCount;
var m_nCommentCountMax;

function replaceForComments(sVal) {
	var sNewValue = sVal.replace(/\|/g, "&#124;");
	sNewValue = sNewValue.replace(/\=/g,"&#61;");
	
	return sNewValue;
}

function InitCommentServer(sURL,sReviewer,sEventCommentsFrameObjectName,windowtargetEventComments) {
	if (windowtargetEventComments == null) {
		CP.m_windowtargetEventComments = parent.content;
	} else {
		CP.m_windowtargetEventComments = windowtargetEventComments;
    }

    CP.m_sTrackingURL = sURL;
	CP.m_sReviewerName = sReviewer;
    if (sEventCommentsFrameObjectName != null) {
        CP.m_sEventCommentsFrameObjectName = sEventCommentsFrameObjectName;
    } else {
        CP.m_sEventCommentsFrameObjectName = "txtPreviousComments";
    }
}

function GetEventCommentsForSCO(sTrackingURL,sSCOID,lEventID) {
	CP.postURL(sTrackingURL,"action=getEventComments|scoid=" + unescape(sSCOID) + "|eventid=" + String(lEventID),postGetEventCommentsComplete);
}

function GetEventComments() {
	CP.postURL(CP.m_sTrackingURL,"action=getEventComments|scoid=" + unescape(CP.m_sSCOID) + "|eventid=" + String(CP.m_lAliasID),postGetEventCommentsComplete);
}

function postGetEventCommentsComplete(obj) {
	CP.SetText(CP.m_sEventCommentsFrameObjectName,obj.content,CP.m_windowtargetEventComments);
}

function SubmitComment(sname,svalue) {
	m_bPostSuccess = true;
	if (svalue != "") {
		CP.postURL(CP.m_sTrackingURL,"action=addComment|scoid=" + unescape(CP.m_sSCOID) + "|reviewername=" + replaceForComments(CP.m_sReviewerName) + "|eventid=" + String(CP.m_lAliasID) + "|objectname=" + sname + "|comment=" + replaceForComments(svalue) + "|timestamp=" + CP.getDateTimestamp(),postComplete);
	}	
}

function SubmitComments() {
	var colComments = CP.m_windowtargetEventComments.document.getElementsByName("comments");

	m_bPostSuccess = true;
	m_nCommentCount = 0;
	m_nCommentMaxCount = countComments();
	
	for (var i = 0; i<colComments.length; i++) {
		var objComment = colComments.item(i);
		if (objComment.value != "") {
			CP.postURL(CP.m_sTrackingURL,"action=addComment|scoid=" + unescape(CP.m_sSCOID) + "|reviewername=" + replaceForComments(CP.m_sReviewerName) + "|eventid=" + String(CP.m_lAliasID) + "|objectname=" + objComment.id + "|comment=" + replaceForComments(objComment.value) + "|timestamp=" + CP.getDateTimestamp(),postComplete);
		}	
	}
}
		
function postComplete(obj) {
    m_nCommentCount++;

	if (obj.content.substring(0,7).toLowerCase() != "success") {
		m_bPostSuccess = false;
	}
	
	// If the last one posted then give feedback
	if (m_nCommentCount == m_nCommentMaxCount) {
		if (m_bPostSuccess) {
			//alert("Your comments have successfully been submitted.");
            clearAllComments();
            CP.GetEventComments();
		} else {
			alert("There was a problem posting the data to the server. Make sure the Tracking URL is correct and that the server is running.");
		}
	}
}

function clearAllComments() {
    var colComments = CP.m_windowtargetEventComments.document.getElementsByName("comments");

	for (var i = 0; i<colComments.length; i++) {
		var objComment = colComments.item(i);
        // Clear contents of editbox
        CP.SetEditboxValue(objComment.id,"",CP.m_windowtargetEventComments);
    }
}

function countComments() {
	var m_nCount = 0;
	var colComments = CP.m_windowtargetEventComments.document.getElementsByName("comments");

	for (var i = 0; i<colComments.length; i++) {
		var objComment = colComments.item(i);
		if (objComment.value != "") {
			m_nCount++;
		}	
	}
	
	return m_nCount;
}

// *** AJAX API
function pickRecentProgID(idList)
{
	// found progID flag
	var bFound = false;
	for (var i=0; i < idList.length && !bFound; i++)
	{
		try
		{
			var oDoc = new ActiveXObject(idList[i]);
			o2Store = idList[i];
			bFound = true;
		}
		catch (objException)
		{
			// trap; try next progID
		}
	}
	if (!bFound)
		throw "Could not retreive a valid progID of Class: " + idList[idList.length-1]+". (original exception: "+e+")";
	idList = null;
	return o2Store;
};

function HTTP() {
	if (IS_IE) {
		var XMLHTTP_PROGID = pickRecentProgID(["Msxml2.XMLHTTP.4.0", "MSXML2.XMLHTTP.3.0", "MSXML2.XMLHTTP", "Microsoft.XMLHTTP"]);
		return new ActiveXObject(XMLHTTP_PROGID);
	} else if (IS_MOZ) {
		return new XMLHttpRequest();
	} else {
		alert("Your browser isn't supported. To be able to do XML posts, IE or a Mozilla based browser is needed.");
	}
}

if (typeof postURL=='undefined') {
	postURL=function(url,txt,fn,type,enc) {
		if (url == "") {
			return;
		}
	
		// needed for Mozilla
		if (IS_MOZ) {
            try {
			    netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
            } catch (e) {
            }
		}	
		var xmlhttp=new HTTP();
		if (xmlhttp) {
            try {
                xmlhttp.open("POST",url,true);
                if (enc) xmlhttp.setRequestHeader("Content-Encoding",enc);
                if (type) xmlhttp.setRequestHeader("Content-Type",type);
                xmlhttp.onreadystatechange=function() {
                    if (xmlhttp.readyState==4) {
                        fn({status:xmlhttp.status,content:xmlhttp.responseText});
                    }
                }
                xmlhttp.send(txt);
            } catch (e) {
            }
		} else {
			//Some Appropriate Fallback...
		}
	}
}
