﻿// ©  Copyright IBM Corp. 1998 - 2004 All Rights Reserved
var m_arrPopupWin = new Array();

function isFullURL(sURL){
	if (sURL.substring(0,5) == "http:" || sURL.substring(0,6) == "https:" || sURL.substring(0,5) == "file:" || sURL.substring(0,4) == "ftp:" || sURL.substring(0,1) == "/" || sURL.substring(1,2) == ":"){
		return true;      
	}
	return false;
}	

function OpenWindow(url,windowNumber,windowName,replace,left,top,width,height,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative) {
	if (windowNumber==null || windowNumber==0 || windowNumber=="") windowNumber=1;
	if (windowName==null || windowName==0 || windowName=="") windowName="";
	if (replace==null || replace==0 || replace=="") replace='';
	if (String(replace).toLowerCase()=="yes") replace=true;
	if (String(replace).toLowerCase()=="no") replace=false;
	if (left==null || left==0 || left=="") left=0;
	if (top==null || top==0 || top=="") top=0;
	if (width==null || width==0 || width=="") width=800;
	if (height==null || height==0 || height=="") height=600;
	if (resizable==null || resizable==0 || resizable=="") resizable=0;
	if (scrollbars==null || scrollbars==0 || scrollbars=="") scrollbars=0;
	if (toolbar==null || toolbar==0 || toolbar=="") toolbar=0;
	if (menubar==null || menubar==0 || menubar=="") menubar=0;
	if (location==null || location==0 || location=="") location=0;
	if (status==null || status==0 || status=="") status=0;
	if (bForceRelative==null) bForceRelative = false;

    if (!bForceRelative) {
		if (!isFullURL(url)){
			url = m_sContentDir + "/" + url;
		}		
	}
	var options = "left=" + left + ",top=" + top + ",width=" + width + ",height=" + height + 
		",resizable=" + resizable + ",scrollbars=" + scrollbars +
		",toolbar=" + toolbar + ",menubar=" + menubar + ",location=" + location + ",status=" + status;

	if (windowName==null || windowName=="") {
		windowName=="";
	} else {
		windowName=windowName+"_"+windowNumber;
	}

	// no window or window closed
	if (m_arrPopupWin[windowNumber-1] == null || m_arrPopupWin[windowNumber-1].closed) {
		m_arrPopupWin[windowNumber-1]=window.open(url,windowName,options);
		return m_arrPopupWin[windowNumber-1];
	// already content in window
	} else {
		if (windowName=="") {
			m_arrPopupWin[windowNumber-1]=window.open(url,windowName,options);
			return m_arrPopupWin[windowNumber-1];
		} else if (replace) {
			m_arrPopupWin[windowNumber-1]=window.open(url,windowName,options);
			m_arrPopupWin[windowNumber-1].focus();
			return m_arrPopupWin[windowNumber-1];
		} else {
			m_arrPopupWin[windowNumber-1].focus();
		}
	}
}

function OpenWindowAndCenter(url,windowNumber,windowName,replace,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative) {
	var screentop;
	var screenleft;
	
	screenleft = (top.screen.width-width)/2-6;
		
	if (centertop == null) {
		centertop = false;
	}

	if (centertop == true) {
		screentop = 0;
	} else {
		screentop = (top.screen.height-height)/2-6;
	}
	if (resizable == null) resizable = "yes";
	if (scrollbars == null) scrollbars = "yes";
	if (toolbar == null) toolbar = "no";
	if (menubar == null) menubar = "no";
	if (location == null) location = "no";
	if (status == null) status = "no";
		
	return OpenWindow(url,windowNumber,windowName,replace,screenleft,screentop,width,height,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative);
}

function OpenPersistentWindowAndCenter(url,windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative) {
	return OpenWindowAndCenter(url,windowNumber,"popup",false,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative);
}

function OpenReusableWindowAndCenter(url,windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative) {
	return OpenWindowAndCenter(url,windowNumber,"popup",true,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative);
}

function OpenNewWindowAndCenter(url,windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative) {
	return OpenWindowAndCenter(url,windowNumber,"",false,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative);
}

function OpenWindowFullScreen(url,bForceRelative){
	if (bForceRelative==null) bForceRelative = false;

    if (!bForceRelative) {
		if (!isFullURL(url)){
			url = m_sContentDir + "/" + url;
		}		
	}

    return window.open(url,"","fullscreen=1");
}	

function LaunchEvent(sEventID,windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status) {
    return OpenReusableWindowAndCenter(GetURLForEvent(sEventID),windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,true)
}

function LaunchSCO(sSCOID,windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status) {
    return OpenReusableWindowAndCenter(GetURLForSCO(sSCOID),windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,false)
}

function GetURLForEvent(sEventID) {
    var eNum=CP.GetEventRefNumFromName(sEventID);
    return "index.htm?eventref=" + eNum + "&tracking=none";
}

function GetURLForEventAndFrame(sEventID, sFrameID) {
    var eNum=CP.GetEventRefNumFromName(sEventID);
    var nFrameNum = CP.GetFrameIndexFromNameForCurrentEvent(sFrameID);
    return "index.htm?eventref=" + eNum + "&framenum=" + nFrameNum + "&tracking=none";
}

function GetURLForSCO(sSCOID,sEventID) {
    // Need to convert backslahses to forward slashes
    return "scos/" + replaceAll(sSCOID,"\\","/") + "/index.htm?tracking=none";
}

function GetURLForSCOAndEvent(sSCOID,sEventID) {
    var eNum=CP.GetEventRefNumFromName(sEventID);
    // Need to convert backslahses to forward slashes
    return "scos/" + replaceAll(sSCOID,"\\","/") + "/index.htm?eventref=" + eNum + "tracking=none";
}

function GetURLForSCOAndEventAndFrame(sSCOID,sEventID,sFrameID) {
    var eNum=CP.GetEventRefNumFromName(sEventID);
    var nFrameNum = CP.GetFrameIndexFromNameForCurrentEvent(sFrameID);
    // Need to convert backslahses to forward slashes
    return "scos/" + replaceAll(sSCOID,"\\","/") + "/index.htm?eventref=" + eNum + "&framenum=" + nFrameNum + "tracking=none";
}

function ExitSCO() {
	parent.close();
}
