﻿function CEditbox(sEditboxObject,targetwindow) {
	//-------------property declaration-----------------//
	initialize();
	
	this.editboxObject								=	sEditboxObject;
	
	if(targetwindow == null) {
		this.windowTarget							=	parent.content;
	} else {
		this.windowTarget							=	targetwindow;
	}

	//------------class inheritance and frame object validation----------//
	var objUtil												=	new CUtil();
	var objFrameObject	 							=	new CFrameObject(this.editboxObject,this.windowTarget);
	this.isFrameObjectExists					=	objFrameObject.isFrameObjectExists();
	
	if(this.windowTarget.arrContent[this.editboxObject] != null) {
		this.defaultText									=	this.windowTarget.arrContent[this.editboxObject].DEFAULT;
		this.rows													=	this.windowTarget.arrContent[this.editboxObject].ROWS;
		this.cols													=	this.windowTarget.arrContent[this.editboxObject].COLS;
		this.readonly											=	this.windowTarget.arrContent[this.editboxObject].READONLY;
		this.multiline										=	this.windowTarget.arrContent[this.editboxObject].MULTILINE;
		this.caseSensative								=	this.windowTarget.arrContent[this.editboxObject].CASESENSATIVE;
	}

	//-------------method declaration-----------------//
	this.getEditboxDefault						=	_getEditboxDefault;
	this.getEditboxRows								=	_getEditboxRows;
	this.getEditboxCols								=	_getEditboxCols;
	this.getEditboxReadonly						=	_getEditboxReadonly;
	this.getEditboxMultiline					=	_getEditboxMultiline;
	this.getEditboxCaseSensitive			=	_getEditboxCaseSensitive;
	this.setEditboxValue							=	_setEditboxValue;
	this.getEditboxValue							=	_getEditboxValue;
		
	//------------methods from inherited class----------//
	this.getVisibility							=	function() 									{return objFrameObject.getVisibility() };
	this.setVisibility							=	function(sState) 						{objFrameObject.setVisibility(sState) };
	this.getObjectZIndex						=	function() 									{return objFrameObject.getObjectZIndex() };
	this.setObjectZIndex						=	function(nZIndex) 					{objFrameObject.setObjectZIndex(nZIndex) };	
	this.moveObject									=	function(x,y) 							{return objFrameObject.moveObject(x,y) };
	this.resizeFrameObject					=	function(x,y,width,height)	{return objFrameObject.resizeFrameObject(x,y,width,height) };
	this.getLayerNameForObject			=	function() 									{return objFrameObject.getLayerNameForObject() };
	this.getPositionAndSize					= function()									{return objFrameObject.getPositionAndSize() };	
	
	//-------------method definition-----------------//
	function initialize() {
		if(sEditboxObject == '[object]') {
			sEditboxObject =	new CFrameObject(sEditboxObject).getCurrentFrameObjectName();
		}
	}	
	
	function _getEditboxDefault() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.editboxObject);
		}		
		
		return this.defaultText;
	}

	function _getEditboxRows() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.editboxObject);
		}		
		
		return this.rows;
	}

	function _getEditboxCols() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.editboxObject);
		}		
		
		return this.cols;
	}
	
	function _getEditboxReadonly() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.editboxObject);
		}		
		
		return this.readonly;
	}
	
	function _getEditboxMultiline() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.editboxObject);
		}		
		
		return this.multiline;
	}		
	
	function _getEditboxCaseSensitive() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.editboxObject);
		}		
		
		return this.caseSensative;
	}	
	
	
	function _setEditboxValue(sValue) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.editboxObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_" + this.editboxObject);
		if (obj != null) {  
			if (obj.firstChild.nodeName == "INPUT") {
					obj.firstChild.value = sValue;
		   	} else { // an editbox label was set
		   		obj.children[1].value = sValue;
		   	}	
		}
	}
	
	
	function _getEditboxValue() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.editboxObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_" + this.editboxObject);
		if (obj != null) {  
			if (obj.firstChild.nodeName == "INPUT") {
		   		return obj.firstChild.value;
		   	} else { // an editbox label was set
		   		return obj.children[1].value;
		   	}	
		} else {
			if(m_debug == true) {
				alert("Error! The object " + this.editboxObject + " doesn't exist.");
			}
			return "";
		}		
	}
	
	//-------------------------------------------------------//
}			//class