﻿function CFrame(sFrameID,sFrameName,targetwindow) {
	//-------------property declaration-----------------//
	this.frameID						=	sFrameID;
	this.frameName					=	sFrameName;
	this.parentEngine				=	parent.engine;
	
	if(targetwindow == null) {
		this.windowTarget							=	parent.content;
	} else {
		this.windowTarget							=	targetwindow;
	}	

	//-------------method declaration-----------------//
	this.getIndex		=	_getIndex;
	this.getName		=	_getName;
	
	this.loadFrame	=	_loadFrame;
	
	//-------------method definition-----------------//
	function _getIndex() {
		return this.frameID;
	}

	function _getName() {
		return this.frameName;
	}	

	function _loadFrame(lEventID,bLoadEvent,sBMAnchor) {
		var objUtil = new CUtil();
		lFrameID = this.frameID;
		
		// clear any animation intervals
		for (var i=0;i<m_arrAnimationInterval.length;i++){
			clearInterval(m_arrAnimationInterval[i]);
		}
		m_arrAnimationInterval = new Array();

		var sFilename = objUtil.replaceAll(objUtil.replaceAll(this.parentEngine.m_sPublishedFilename,"{eventid}",lEventID),"{framenum}",lFrameID);
		var sExt = this.parentEngine.m_sPublishedExtension;
		var sFullFilename = sFilename + "." + sExt;
				
		if (sBMAnchor==null){sBMAnchor="";}	
		var sExternalURL = convertNull(m_arrEvents[String(m_lEventID)].EXTERNALURL);
		if (sExternalURL.indexOf('[url]') != -1){
			sExternalURL = sExternalURL.substring(6,sExternalURL.length);
			sExternalURL = objUtil.buildFullURL(sExternalURL);
		}else{
			if (sExternalURL != ""){
				sExternalURL = objUtil.buildFullURL("media/" + sExternalURL);
			}			
		}		
		
		if (bLoadEvent == null) {
			bLoadEvent = false;
		}
	
		if (!bLoadEvent) {
			m_lLastEventID = m_lEventID;
		}	
		
		var sFontStyleCSS = "fontstyles.css";
		var sBorderStyleCSS = "borderstyles.css";
	
		if (m_bPooledEvent == true){
			sFontStyleCSS = objUtil.replaceAll(objUtil.replaceAll(m_sAliasSCOID,"/","-")," ","_") + "_" + sFontStyleCSS;
			sBorderStyleCSS = objUtil.replaceAll(objUtil.replaceAll(m_sAliasSCOID,"/","-")," ","_") + "_" + sBorderStyleCSS;
		}	
	
		// Need to handle IFRAME
		clearTimeout(m_nTimeoutID);
		m_lFrameID = lFrameID;
		var oEvent = new CEvent(m_lEventID);
		sTarget = oEvent.getTarget();
		//sTarget = getTarget(m_lEventID);
	
		var xslProc;
		
		if (m_bDynamic && sExternalURL == "") {
			var xslt = new ActiveXObject("Msxml2.XSLTemplate");
			var xslDoc = new ActiveXObject("Msxml2.FreeThreadedDOMDocument");
			var xslProc;
			xslDoc.async = false;
			xslDoc.resolveExternals = false;  
			xslDoc.load(m_sEngineDir + "/cppublish.xsl");
			xslt.stylesheet = xslDoc;
			var xmlDoc = new ActiveXObject("Msxml2.DOMDocument");
			xmlDoc.async = false;
			xmlDoc.resolveExternals = false;
			xmlDoc.load(m_sContentDir + "/scos/" + unescape(m_sAliasSCOID) + ".xml");
			xslProc = xslt.createProcessor();
			xslProc.input = xmlDoc;
			// need to get somehow
			xslProc.addParameter("cplibdir", m_sLibDir);
			xslProc.addParameter("enginedir", m_sEngineDir);
			xslProc.addParameter("contentdir", m_sContentDir);
		   xslProc.addParameter("multipubrel", m_bMultiPubRel);
	
			// may not need
			//xslProc.addParameter("sco", m_sAliasSCOID.replace("%5c","\\").replace("%20"," "));
			xslProc.addParameter("sco", unescape(m_sAliasSCOID));
			xslProc.addParameter("eventid", lEventID);
			xslProc.addParameter("framenum", lFrameID);
			xslProc.addParameter("aliasid", m_lEventID);
			xslProc.addParameter("fontstylecss", sFontStyleCSS);
			xslProc.addParameter("borderstylecss", sBorderStyleCSS);
			
			var sMergeContent = "";
			var sMergeFrameList = "";
			var sMergeLayout = "";


			var objCurEvent = xmlDoc.selectSingleNode("/SCO/EVENTS/*[@ID='" + lEventID + "']");

			xslProc.addParameter("storyboardmode","false");
	
			xslProc.transform();
		}
	
		if (sTarget != null && sTarget != "") {
			var arrTargets = new Array();
			arrTargets = sTarget.split(";");
			
			var sFramesPath = "";
			
			sFramesPath = "parent.content";
	
			for (var i=0; i<arrTargets.length; i++) {
				sFramesPath = sFramesPath + ".frames['" + arrTargets[i] + "']";  
			}
			
			var oFramesPath;
			oFramesPath = eval(sFramesPath);
				
			if (sExternalURL != ""){
				oFramesPath.location.href = sExternalURL;
				return;
			}			
			
			if (m_bDynamic) {
				oFramesPath.parent.engine = parent.engine;
				oFramesPath.document.open();
				oFramesPath.document.write(xslProc.output);
				oFramesPath.document.close();
				if (sBMAnchor != ""){
					oFramesPath.document.location.href = "#" + sBMAnchor;
				}	
			} else {
				oFramesPath.parent.engine = parent.engine;
				
				if (sBMAnchor != ""){
					sBMAnchor = "#" + sBMAnchor;	
				}	
				
				var sTempSCOID = "";
				if (m_bPooledEvent == true){
					sFullFilename = objUtil.replaceAll(objUtil.replaceAll(m_sAliasSCOID,"/","-")," ","_") + "_" + sFullFilename;
					sTempSCOID = m_sAliasSCOID;
					m_sAliasSCOID = m_sSCOID;
				}		
				
				if (m_sContentDir == ".") {
					oFramesPath.location.href = sFullFilename + sBMAnchor;
				} else {
					oFramesPath.location.href = m_sContentDir + "/scos/" + objUtil.replaceAll(objUtil.replaceAll(objUtil.replaceAll(m_sAliasSCOID,"%5c","/"),"%5C","/"),"%20"," ") + "/" + sFullFilename + sBMAnchor;
				}	
				
	 			if (m_bPooledEvent == true){
					m_sAliasSCOID = sTempSCOID;
				}	
	
			}	
		} else {
			if (sExternalURL != ""){
				this.windowTarget.location.href = sExternalURL;
				return;
			}	
	
			if (m_bDynamic) {
				this.windowTarget.document.open();
				this.windowTarget.document.write(xslProc.output);
				this.windowTarget.document.close();
				if (sBMAnchor != "") {
					this.windowTarget.document.location.href = "#" + sBMAnchor;
				}	
				
			} else {
				
				if (sBMAnchor != ""){
					sBMAnchor = "#" + sBMAnchor;	
				}
				var sTempSCOID = "";
				if (m_bPooledEvent == true){
					sFullFilename = objUtil.replaceAll(objUtil.replaceAll(m_sAliasSCOID,"/","-")," ","_") + "_" + sFullFilename;
					sTempSCOID = m_sAliasSCOID;
					m_sAliasSCOID = m_sSCOID;
				}		
				if (m_sContentDir == ".") {
					this.windowTarget.location.href = sFullFilename + sBMAnchor;
				} else {
					this.windowTarget.location.href = m_sContentDir + "/scos/" + replaceAll(replaceAll(replaceAll(m_sAliasSCOID,"%5c","/"),"%5C","/"),"%20"," ") + "/" + sFullFilename + sBMAnchor;
				}	
				if (m_bPooledEvent == true){
					m_sAliasSCOID = sTempSCOID;
				}	
			}	
		}	
	}	
	
	//--------------------------------------------------------//
	
}			//class