﻿function COptionButton(sOptionObject,targetwindow) {
	//-------------property declaration-----------------//
	initialize();
	
	this.optionObject									=	sOptionObject;
	
	if(targetwindow == null) {
		this.windowTarget							  =	parent.content;
	} else {
		this.windowTarget							  =	targetwindow;
	}


	//------------class inheritance and frame object validation----------//
	var objUtil												=	new CUtil();
	var objFrameObject	 							=	new CFrameObject(this.optionObject,this.windowTarget);
	this.isFrameObjectExists					=	objFrameObject.isFrameObjectExists();
	this.isGroupExists								=	objFrameObject.isObjectGroupExists();
	
	if(this.windowTarget.arrContent[this.optionObject] != null) {
		this.jumpToPath										=	this.windowTarget.arrContent[this.optionObject].JUMPTO;
	}

	//-------------method declaration-----------------//
	this.getOptionJumpToPath					=	_getOptionJumpToPath;
	this.setOptionCaption							=	_setOptionCaption;
	this.getOptionCaption							=	_getOptionCaption;
	this.setOptionChecked							=	_setOptionChecked;
	this.getOptionChecked							=	_getOptionChecked;
	this.getOptionFrameNumber					=	_getOptionFrameNumber;
	this.isOptionChecked							=	_isOptionChecked;


	//------------method from inherited class----------//	
	this.getVisibility							=	function() 									{return objFrameObject.getVisibility() };
	this.setVisibility							=	function(sState) 						{objFrameObject.setVisibility(sState) };
	this.getObjectZIndex						=	function() 									{return objFrameObject.getObjectZIndex() };
	this.setObjectZIndex						=	function(nZIndex) 					{objFrameObject.setObjectZIndex(nZIndex) };	
	this.moveObject									=	function(x,y) 							{return objFrameObject.moveObject(x,y) };
	this.resizeFrameObject					=	function(x,y,width,height)	{return objFrameObject.resizeFrameObject(x,y,width,height) };
	this.getLayerNameForObject			=	function() 									{return objFrameObject.getLayerNameForObject() };
	this.getPositionAndSize					= function()									{return objFrameObject.getPositionAndSize() };

	//-------------method definition-----------------//
	function initialize() {
		if(sOptionObject == '[object]') {
			sOptionObject =	new CFrameObject(sOptionObject).getCurrentFrameObjectName();
		}
	}
		
	function _getOptionJumpToPath() {
		if(this.isGroupExists == true && this.isFrameObjectExists == false) {
			alert('Cannot perform this function for the group - ' + this.optionObject);
			return null;
		}	
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.optionObject);
		}		
		
		return this.jumpToPath;
	}
	
	
	function _setOptionCaption(sCaption) {
		if(this.isGroupExists == true && this.isFrameObjectExists == false) {
			alert('Cannot perform this function for the group - ' + this.optionObject);
			return null;
		}		
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.optionObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_" + this.optionObject);
		if (obj != null) {
			if (obj.firstChild.nextSibling.firstChild.nodeName != "#text") {
				obj.firstChild.nextSibling.firstChild.innerHTML = sCaption;
			} else {
				obj.firstChild.nextSibling.innerHTML = sCaption;
			}	
		}
	}
	

	function _getOptionCaption() {
		if(this.isGroupExists == true && this.isFrameObjectExists == false) {
			alert('Cannot perform this function for the group - ' + this.optionObject);
			return null;
		}		
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.optionObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_" + this.optionObject);
		if (obj != null) {
			if (obj.firstChild.nextSibling.firstChild.nodeName != "#text") {
				return obj.firstChild.nextSibling.firstChild.innerHTML;
			} else {
				return obj.firstChild.nextSibling.innerHTML;
			}	
		} else {
			if(m_debug == true) {
				alert("Error! The object " + this.optionObject + " doesn't exist.");
			}
			return "";
		}
	}
	
	
	function _setOptionChecked(bChecked) {
		if(this.isGroupExists == true && this.isFrameObjectExists == false) {
			alert('Cannot perform this function for the group - ' + this.optionObject);
			return null;
		}		
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.optionObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_" + this.optionObject);
		if (obj != null) {
				obj.firstChild.checked = bChecked;
				//obj.firstChild.checked = (bChecked.toLowerCase()=="true"?true:false);
			}	
	}
	
	function _getOptionChecked() {
		if(this.isGroupExists == true && this.isFrameObjectExists == false) {
			alert('Cannot perform this function for the group - ' + this.optionObject);
			return null;
		}
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.optionObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_" + this.optionObject);
		if (obj != null) {
				return obj.firstChild.checked;
			}	
	}
	
	
	function _getOptionFrameNumber() {
		var arrChk=this.windowTarget.document.getElementsByName(this.optionObject);
		var foid;   
		for (var i=0; i<arrChk.length; i++) {   
			foid = GetFrameObjectNameFromDOM(arrChk[i]);   
			var oOption = new COptionButton(foid);
			
			if (arrChk[i].checked==true) {
				if (convertNull(oOption.jumpToPath) != null){
					if (convertNull(oOption.jumpToPath) != ""){
						return convertNull(oOption.jumpToPath);		  
					}  
				}  
			}
		}			
	
		return;
	}	
	

	function _isOptionChecked() {
		if(this.isGroupExists == true && this.isFrameObjectExists == false) {
			alert('Cannot perform this function for the group - ' + this.optionObject);
			return null;
		}		
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.optionObject);
		}		
		
		if(Boolean(this.getOptionChecked()) == true) {
			return true;
		}
		else {
			return false;
		}
	}
	
	
	//----------------------------------------------------//
}		//class