﻿function CXHTMLElement(elementName) {
	//-------------property declaration-------------//
	this.elementName 						= elementName;
	this.text 									= "";
	this.childArray 						= new Array();
	this.attributes 						= new Array();
	
	//-------------method declaration-------------//
	this.appendChild 						= _appendChild;
	this.setAttribute 					= _setAttribute;
	this.xhtml 									= _xhtml;	
	this.XHTMLCreateAttribute		=	_XHTMLCreateAttribute;
	
	
	//-------------method definition-------------//	
	function _appendChild(oXHTMLElement) {
		this.childArray = arrPush(this.childArray,oXHTMLElement);
	}		
	
	function _setAttribute(oXHTMLAttribute) {
		this.attributes = arrPush(this.attributes,oXHTMLAttribute);
	}	
	
	function _xhtml() {
		var sstr = "";
		sstr = "<" + this.elementName;
		if (this.attributes.length > 0){
			for (var i=0;i<this.attributes.length;i++){
				sstr = sstr + " " + this.attributes[i].attributeName + "=\"" + this.attributes[i].text + "\"";
			}
		}
		if (this.childArray.length > 0 ){
			sstr = sstr + ">";
			for (var i=0;i<this.childArray.length;i++){
				sstr = sstr + this.childArray[i].xhtml();
			}				
			sstr = sstr + "</" + this.elementName + ">";
		}else{
			if (this.text == ""){
				sstr = sstr + "/>";
			}else{	
				sstr = sstr + ">";
				sstr = sstr + this.text;
				sstr = sstr + "</" + this.elementName + ">";
			}
			
		}
		
		return sstr;
	}	
		
	function _XHTMLCreateAttribute(sAttributeName,sAttributeValue) {
		var oAttr = new CXHTMLAttribute(sAttributeName);
		oAttr.text = sAttributeValue;
		this.setAttribute(oAttr);
	}		
	
	//--------------------------------------------------------//
}			// class